#!/usr/bin/pl -q -t main -f

%% 
%% This can be piped before krh to allow noncanonical input.
%% Usage eg.: canfilter.pl | krh -tty myconfig.tme -
%% Does not (yet?) handle CTRL-C properly.
%%

:- op(500, fx, #).

canonicalize :-
	( repeat,
          catch(read_term(user_input, Term, [double_quotes(atom)]),
		_,
		(write(user_error,
		 'canfilter: Ignoring input with syntax error.'),
		 nl(user_error),
		 flush_output(user_error),
		 fail)),
	  ( Term == end_of_file ->
	    !
	  ; write_term(Term, [quoted(true),ignore_ops(true),portray(true)]),
	    writeln('.'),
	    flush_output,	      	      
	    fail
	  )
	  ; true
	).

handler(_) :-
 	fail.

main :-
	fix_ops,
	prompt(_,''),
	on_signal(int, _, handler),
	canonicalize,
        halt.                                           
main :-
        halt(1).

%%%%  
%%%% SWI-prolog prints operators >= 1000 in brackets (also if
%%%% ignore_ops is true). portray is used here to patch this.
%%%%  
fix_ops :-
	findall(O, (current_op(P,_,O), P >= 1000), Os),
	sort(Os, Os1),
	( member(O1, Os1),
	  asserta(portray(O1) :- write_term(O1, [quoted(true)])),
	  fail
	; true
	).
