#!/usr/bin/pl -q -t main -f

:- use_module('../contrib/pl/swilib/pretty').
:- use_module('script_support').

main :-
        main(before(_), prettyprint_clause_bottom_up(_), true).

prettyprint_clause_bottom_up((H :- B)) :-
        !,
        numbervars(B-H, 0, _),
        pp_clause((H :- B)),
	nl.
prettyprint_clause_bottom_up(C) :-
        pp_clause(C),
	nl.

before(Options) :-
	( extract_option_value('init=', Options, InitFile) ->
	  consult(InitFile)
	; true
	).

extract_option_value(Key, Options, Value) :-
	atom_length(Key, L),
	member(Option, Options),
	sub_atom(Option, 0, L, _, Key),
	!,
	sub_atom(Option, L, _, 0, Value).

