(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** Implementation of some Built-Ins. *)

(** Initialize the association of builtins and predicate
   symbols for the given symbol_table. This function has to be called
   on a symbol table, before the builtins can be used. *) 
val init_builtins : Term.symbol_table -> unit

(** Remove the association of builtins and predicate symbols
   for the given symbol_table.
*)
val clear_builtins : Term.symbol_table -> unit

(** {6 Extending the System with Built-Ins} *)

(** [register_builtin symbol_table name arity implementation] effects that
   the predicate [name]/[arity] becomes available as builtin. See module term
   for more information. *)
val register_builtin : Term.symbol_table -> string -> int -> Term.p -> unit
