(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(* Implementation after 
   http://www.bagley.org/~doug/ocaml/io_lib/io_lib.ml *)

let from_file fn filename =
  let chan = open_in filename in
  let fd_i = Unix.descr_of_in_channel stdin
  and fd_c = Unix.descr_of_in_channel chan in
  let dup_i = Unix.dup fd_i in
  Unix.dup2 fd_c fd_i;
  try 
    fn ();
    Unix.dup2 dup_i fd_i;
    Unix.close dup_i;
    close_in chan
  with e ->
    Unix.dup2 dup_i fd_i;
    Unix.close dup_i;
    close_in chan;
    raise e

let onto_file fn filename =
  flush stdout;
  let chan = open_out filename in
  let fd_o = Unix.descr_of_out_channel stdout
  and fd_c = Unix.descr_of_out_channel chan in
  let dup_o = Unix.dup fd_o in
  Unix.dup2 fd_c fd_o;
  try 
    fn ();
    flush stdout;
    Unix.dup2 dup_o fd_o;
    Unix.close dup_o;
    close_out chan
  with e ->
    Unix.dup2 dup_o fd_o;
    Unix.close dup_o;
    close_out chan;
    raise e
      

