(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** Redirecting stdin and stdout. *)

(** [from_file function filename] calls function with [stdin]
temporary redirected from the specified file. If [function]
raises an exception, [stdin] is reset to its previous value 
before the exception is raised again. *)
val from_file : (unit -> unit) -> string -> unit

(** [onto_file function filename] calls function with [stdout]
temporary redirected to the specified file. If [function]
raises an exception, [stdout] is reset to its previous value 
before the exception is raised again. *)
val onto_file : (unit -> unit) -> string -> unit
