(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

module type EntryType =
    sig
      type entry
      val get_term : entry -> Term.term
    end

module type Index =
  sig
    type entry
    type index
    val make_index : unit -> index	  
    val clear : index -> unit
    val insert : index -> Term.term -> entry -> unit
    val remove_variant : index -> Term.term -> unit
    val iter_all : (entry -> unit) -> index -> unit
    val iter_all_and_throw_away : (entry -> unit) -> index -> unit
    val iter_instance_candidates :
	(entry -> unit) -> index -> Term.term -> Term.context -> unit
    val iter_variant_candidates :
	(entry -> unit) -> index -> Term.term -> Term.context -> unit    
	val iter_generalization_candidates :
	(entry -> unit) -> index -> Term.term -> Term.context -> unit
    val iter_unification_candidates :
	(entry -> unit) -> index -> Term.term -> Term.context -> unit
    val size : index -> int    
  end

