(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)


let push elem listref =
  listref := elem :: !listref

let pushnew elem listref =
  if List.mem elem !listref then
    ()
  else
    listref := elem :: !listref

let pushnewq elem listref =
  if List.memq elem !listref then
    ()
  else
    listref := elem :: !listref

let rec rm_duplicates list =
  match list with
    e1 :: e2 :: list1 ->
      if e1 = e2 then
	rm_duplicates (e2 :: list1)
      else
	e1 :: rm_duplicates (e2 :: list1)
  | _ -> list

let sort_without_duplicates list =
  rm_duplicates (List.fast_sort compare list)

