(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** Utility functions for list manipulation. *)

(** [push element listref] effects that [element] is added to the beginning
   of the list in [listref].
*)
val push : 'a -> 'a list ref -> unit

(** [pushnew element listref] effects that [element] is added to the beginning
   of the list in [listref] if it is not equal to a member of the list. 
*)
val pushnew : 'a -> 'a list ref -> unit

(** Same as [pushnew], but physical equality is used to compare
   list elements.
*)
val pushnewq : 'a -> 'a list ref -> unit

(** The result list is the input list, sorted by [Pervasives.compare] and
   with duplicate elements removed. *)
val sort_without_duplicates : 'a list -> 'a list
