(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

type entry =
    Fact.entry

type index = 
    (entry list) ref

let make_index () =
  ref []

let clear index =
  index := []

let insert index term entry =
  index := entry :: !index

let iter_all f index =
  List.iter f !index

let iter_all_and_throw_away f index =
  List.iter f !index

let iter_instance_candidates f index term context =
  List.iter f !index

let iter_variant_candidates f index term context =
  List.iter f !index  
  
let iter_generalization_candidates f index term context =
  List.iter f !index

let iter_unification_candidates f index term context =
  List.iter f !index

let rec remove_variant_1 index term =
  match index with
    entry :: entries ->
      if Term.variant term (Fact.get_term entry) then
	entries
      else
	entry :: remove_variant_1 entries term
  | [] ->
      []

let remove_variant index term =
  index := remove_variant_1 !index term 

let size index =
  List.length !index
