(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** Printing terms in ISO-Prolog syntax. *)

(** Print the given term in ISO-Prolog syntax, as by Prolog's
   [write_canonical] predicate to stdout.

   - Lists are written using Prolog's list notation with square brackets.
 *)
val print : Term.term -> unit

(** Same as [print], but with the output channel as argument. 
*)
val output : out_channel -> Term.term -> unit         

(** Same as [print], but instead of printing, it returns a
string containg the output.
*)
val print_to_string : Term.term -> string

        
