(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** ISO-Prolog parser. See module PrologGenlex for restrictions on input.

   - Additionally Prolog list notation (i.e. lists and conses using square
 brackets) is accepted. 
*)

(** Parse the given ISO-Prolog clauses. Input is a stream of characters,
   containing clauses, each terminated by a full stop, as usual in Prolog.
   Output is a stream of terms, corresponding to the clauses in the input.
   The output terms are standardized apart from each other (i.e. variable
   objects are not shared). The variable numbers in each output term
   are assigned starting from 0.
 *) 
val prolog_parser : Term.symbol_table -> char Stream.t -> Term.term
    Stream.t



         


        
