(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** Sharing of input terms. *)

type table

val make_table : unit -> table

val null_table : table

(** [share_subterms table term] returns a variant of term with
   subterms replaced as far as possible by subterms stored in [table].
   Subterms not already in the table are inserted.

   This function is intended to be called on propositional (instead of
   functional) terms. Since handling of variants on the propositional
   level is usually performed using other means such as subsumption,
   only proper subterms of [term] are considered for sharing.

   Only subterms which are ground are shared.
*)
val share_subterms : table -> Term.term -> Term.term
