(*
* Copyright (C) 2003 Universitaet Koblenz-Landau
* 
* This file is part of KRHyper.
* 
* KRHyper is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
* 
* KRHyper is distributed in the hope that it will be useful, but WITHOUT ANY
* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
* details.
* 
* You should have received a copy of the GNU General Public License along with
* KRHyper; if not, write to the Free Software Foundation, Inc., 59 Temple
* Place, Suite 330, Boston, MA 02111-1307 USA
* 
* Contributor(s): Christoph Wernhard <wernhard@uni-koblenz.de>.
*)

(** Weighing Terms. *)

(** An object of this type specifies how the term weight value for
   a given term is computed. It is passed as argument to [term_weight].
*)
type term_weighing_method =
    SymbolCount (** The size of the term, i.e. the number of occurences of
		   predicate, function and constant symbols as
		   well as variables in it is used. *)
  | Depth (** The depth of the term is used. *)

(** Return the weight of the given term. *)
val term_weight : term_weighing_method -> Term.term -> int



  
