


#ifndef GL_STATISTICS_COLLECTOR_INCLUDED
#define GL_STATISTICS_COLLECTOR_INCLUDED  1


#include <iostream>


namespace gottlob_leitsch 
{


   struct statistics_collector
   {
      unsigned int findmatch1_calls;
      unsigned int nrguesses;
         // How often findmatch1 had to guess.

      unsigned int findmatch2_calls;
      unsigned int nrsplits; 
         // How often findmatch2 could obtain a split.     

      unsigned int findmatch3_calls; 
      unsigned int nrforward;
         // How many atoms findmatch3 could decide by forward reasoning.
      unsigned int nrnomatch;
         // How often findmatch3 found an atom that could not be matched.

      unsigned int findbest_calls;
         // How often findbest was called.

      unsigned int conclusiontrue_calls;
      unsigned int nrconclusiontrue;
         // How often conclusionistrue was called,
	 // and how often it returned true.

     
      statistics_collector( ) 
         : findmatch1_calls(0),
           nrguesses(0),
           findmatch2_calls(0),
           nrsplits(0),
           findmatch3_calls(0),
           nrforward(0),
           nrnomatch(0),
         
           findbest_calls(0),
           conclusiontrue_calls(0),
           nrconclusiontrue(0)
      {
      }
 
   };



   std::ostream& operator << ( std::ostream& , 
		               const application::statistics_collector& );


};

#endif

