------------------------------------------------------------------
-- Paradox, a Finite Domain Model Finder for First Order Logic  --
-- Copyright (c) 2003 Koen Claessen and Niklas Srensson        --
-- {koen,nik}@cs.chalmers.se                                    --
--                                                              --
-- This file is part of Paradox.                                --
--                                                              --
-- Paradox is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public License  --
-- as published by the Free Software Foundation; either version --
-- 2 of the License, or (at your option) any later version.     --
--                                                              --
-- Paradox is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty  --
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See  --
-- the GNU General Public License for more details.             --
--                                                              --
-- You should have received a copy of the GNU General Public    --
-- License along with Paradox; if not, write to the Free        --
-- Software Foundation, Inc., 59 Temple Place, Suite 330,       --
-- Boston, MA 02111-1307 USA.                                   --
------------------------------------------------------------------
module Output where

import IO
  ( hFlush
  , stdout
  )

{-

This module defines a number of output functions.

-}

-------------------------------------------------------------------------
-- putHeader

putHeader :: String -> IO ()
putHeader s =
  do putStr "== "
     putStr s
     putStr " "
     putStrLn (replicate (72 - length s) '=')

-------------------------------------------------------------------------
-- putHeader

putBlock :: Bool -> String -> [String] -> IO ()
putBlock b s ls =
  if b then
    do putHeader s
       hFlush stdout
       sequence_ [ do putStrLn l; hFlush stdout | l <- ls ]
  else
    do return ()

-------------------------------------------------------------------------
-- the end.
