#ifndef __WRAPPER__
#define __WRAPPER__

typedef void SolverWrapper;
typedef void Loc;

extern    SolverWrapper* solver_new(void);
extern    void           solver_free(SolverWrapper* w);

extern    Loc*           loc_new    (uint a);
extern    void           loc_free   (Loc* l);
extern    uint           loc_arity  (Loc* l);

extern    void           solver_clause_begin       (SolverWrapper* w);           
extern    void           solver_clause_add_lit     (SolverWrapper* w, Loc* l, uint s);
extern    void           solver_clause_add_lit_var (SolverWrapper* w, int v);
extern    void           solver_clause_add_lit_con (SolverWrapper* w, int c);
extern    void           solver_clause_add_size    (SolverWrapper* w, int s);
extern    uint           solver_clause_commit      (SolverWrapper* w, int fresh);

extern    void           solver_lit_begin   (SolverWrapper* w, Loc* l, uint sign);
extern    void           solver_lit_add_con (SolverWrapper* w, int c);

extern    uint           solver_read        (SolverWrapper* w);
extern    uint           solver_solve(SolverWrapper* w);
extern    void           solver_dimacs(SolverWrapper* w, char* name);
extern    uint           solver_simplify(SolverWrapper* w);

extern    uint           solver_get_nof_clauses   (SolverWrapper* w);
extern    uint           solver_get_nof_vars      (SolverWrapper* w);
extern    uint           solver_get_nof_conflicts (SolverWrapper* w);

extern    void           solver_set_verbose       (SolverWrapper* w, uint b);

extern    char*          identify (void);



#endif

