/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __AtomIterator__
#define __AtomIterator__
namespace Shell {
class Atom;
class Formula;
class FormulaList;
class AtomIterator
{
public:
  AtomIterator (const Formula&);
  AtomIterator (const FormulaList&);
  ~AtomIterator ();
  bool hasNext ();
  const Atom& next ();
private:
  class Element;
  Formula* _current;
  Element* _reserve;
  void popReserve ();
}; 
}
#endif 
