/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Bag__
#define __Bag__
#include <string>
#include <iostream>
#include "XML.hpp"
using namespace std;
namespace Shell {
class Bag
{
public:
  static void interpret(const string& fileName);
  static void interpret(istream&);
  static void interpret(const XML::Element*);
private:
  class Exception;
  static const XML::DeepElement* toDeep(const XML::Content*);
  static const XML::Element* toElement(const XML::Content*);
  static const XML::EmptyElement* toEmpty(const XML::Content*);
  static const XML::TextElement* toText(const XML::Content*);
  static void readOptions(const XML::Element*);
  static void setParameter(const XML::Element*);
  static void loadKB(const XML::Element*);
  static void dropKB(const XML::Element*);
  static void kbStatus(const XML::Element*);
  static void saturate (const XML::Element* e);
  static void bind (const XML::Element* e);
  static void bye (const XML::Element* e);
  static void ass (const XML::Element* e);
  static void query (const XML::Element* e);
  static const string* find(const XML::Element*,const string& name);
  static bool yesNoToBoolean(const string& yesNo,bool& result);
}; 
}
#endif
