/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef COMPARISON_MAKER_HPP
#define COMPARISON_MAKER_HPP
#include "Comparison.hpp"
namespace BK
{
  template <class T>
  class CMaker {
  public:
    virtual void loadLHS(const T& obj) = 0;
    virtual void loadRHS(const T& obj) = 0;
    virtual Comparison compare() = 0;
    virtual Comparison inverseCompare() = 0;
    virtual void swapSides() = 0;
  protected:
    CMaker() {};
    virtual ~CMaker();
  }; 
}; 
namespace BK
{
  template <class T>
  CMaker<T>::~CMaker()
  {
  };
}; 
#endif
