/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef MATH_HPP
#define MATH_HPP 
#include "jargon.hpp"
#include "BlodKorvDebugFlags.hpp"
#undef DEBUG_NAMESPACE
#ifdef DEBUG_MATH
#  define DEBUG_NAMESPACE "Math"
#endif
#include "debugMacros.hpp"
namespace BK
{
class Math
{
public:
  static long greatestCommonDivisor(long m,long n);
}; 
}; 
#undef DEBUG_NAMESPACE
#ifdef DEBUG_MATH
 #define DEBUG_NAMESPACE "Math"
#endif
#include "debugMacros.hpp"
namespace BK
{
inline
long Math::greatestCommonDivisor(long m,long n)
{
  CALL("greatestCommonDivisor(long m,long n)");
  if ((m <= 1L) || (n <= 1L)) return 1L;
  while (m != n) 
    {
      if (m > n)
	{
	  m -= n;
	}
      else 
 	{
	  n -= m;
	};
    };
  return m;
}; 
}; 
#endif
