/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef NO_DEBUG
#ifndef OBJ_DESC_HPP
#define OBJ_DESC_HPP
#include <iostream>                
#include <cstdlib> 
#include "jargon.hpp"
#include "BlodKorvDebugFlags.hpp"
#include "Debug.hpp"
#include "debugMacros.hpp"
namespace BK 
{
struct ObjDesc 
{
 enum Status { 
   Persistent = 12345678,
   Recycled = 87654321 
 };
 #ifdef DEBUG_ALLOC_OBJ_PTR
  void* objPtr;
 #endif
 #ifdef DEBUG_ALLOC_OBJ_SIZE
  size_t size;
 #endif   
 #ifdef DEBUG_ALLOC_OBJ_STATUS
  Status status;       
 #endif
 #ifdef DEBUG_ALLOC_EVENT_ID
  ulong eventId;
 #endif
  ObjDesc() {};
  ~ObjDesc() {};
 void* operator new (size_t) 
 {
  void* res = ::malloc(sizeof(ObjDesc)); 
  if (!res) 
   Debug::debugFeatureInternalFault(DEBUG_OUT_STR,"!ObjDesc::operator new (size_t)::res");
  return res; 
 };
 void operator delete(void* obj,size_t) 
 {
  free(obj);
 }; 
  void operator delete(void* obj)
  {
    free(obj);
  };
}; 
}; 
namespace std
{
inline 
ostream& operator<<(ostream& str,const BK::ObjDesc& od)
{
 #ifdef DEBUG_ALLOC_OBJ_PTR
  str << "[" << (unsigned long)od.objPtr << "] ";
 #endif
 #ifdef DEBUG_ALLOC_OBJ_SIZE
  str << "size(" << od.size << ") ";
 #endif   
 #ifdef DEBUG_ALLOC_OBJ_STATUS
  str << "status(";
  switch (od.status)
   {
    case BK::ObjDesc::Persistent: str << "Persistent"; break;
    case BK::ObjDesc::Recycled: str << "Recycled"; break;
    default: str << "Unknown(=" << (ulong)od.status << ")";
   };  
  #ifdef DEBUG_ALLOC_EVENT_ID
   str << ',' << od.eventId;  
  #endif
  str << ") ";
 #endif
 return str;
}; 
};
#endif
#endif
