/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef RUNTIME_ERROR_HPP
#define RUNTIME_ERROR_HPP
#include "jargon.hpp"
#ifdef RUNTIME_ERR_OUT
#  define RUNTIME_ERR_OUT_STR std::cout
#else
#  define RUNTIME_ERR_OUT_STR BK::nullStream
#endif
namespace BK 
{
class RuntimeError
{
 public:
  static void report(const char* msg) 
    { 
      if (errorHook) 
	{
	  void (*tmpErrorHook)();
	  tmpErrorHook = errorHook;
	  errorHook = 0;
	  tmpErrorHook();
	};
      reportFun(msg); 
    };
  static void defaultReport(const char* msg);
  static void (*reportFun)(const char* msg);
  static void (*errorHook)();
};
}; 
#endif
