/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __ClausalDefinition__
#define __ClausalDefinition__
namespace Shell {
class Problem;
class Signature;
class PredicateSymbol;
class ClausalDefinition {
public:
  ClausalDefinition (Problem& problem,Signature& signature);
  int findAndReplace ();
private:
  class Counter;
  void deleteAll (const PredicateSymbol* s);
  bool resolveAll (const PredicateSymbol* s, Unit& u, Counter* counter);
  void resolveAllUpon (const PredicateSymbol* s,
		       const Unit& u1,
		       const Unit& u2,
		       Unit& result);
  Problem& _problem;
  Signature& _signature;
}; 
}
#endif
