/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __CodeGenerator__
#define __CodeGenerator__
#include <iostream>
#include "IntegerSet.hpp"
namespace Shell {
class Term;
class TermList;
class Atom;
class Literal;
class LiteralList;
class Clause;
class Unit;
class UnitList;
class CodeGenerator
{
public:
  CodeGenerator(std::ostream& stream);
  void generateCodeForTheories();
private:
  void generate(const UnitList&);
  void generate(const Unit&);
  int generate(const Clause&);
  int generate(const LiteralList&);
  int generate(const Literal&);
  int generate(const Atom&);
  int generate(const TermList&);
  int generate(const Term&);
  std::ostream& _stream;
  Vampire::IntegerSet _funs;
  Vampire::IntegerSet _preds;
  int _counter;
}; 
} 
#endif
