/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#if DEBUG_SHELL
#ifndef __Debugger__
#define __Debugger__
#include <string>
using namespace std;
namespace Shell {
class Debugger {
public:
  static bool allocated (void* memory, int words, const string& className);
  static bool released (void* memory, int words, const string& className);
  static bool reallocated (void* memory, int words, const string& className);
  static void reportLeaks (ostream& str);
  struct Info {
    int size; 
    string className; 
    Info (int sz, const string& nm) : size(sz), className(nm) {}
    Info () {}
  };
  class Leaker {
  public:
    Leaker (ostream& str) : _stream (str) {}
    ~Leaker () { Debugger::reportLeaks(_stream); }
  private:
    ostream& _stream;
  }; 
private:
  class Memory;
  static Memory* _allocatedPieces;
  static Memory* initialiseMemory();
};
}
#endif 
#endif 
