/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __FormulaVarIterator__
#define __FormulaVarIterator__
#include "Var.hpp"
#include "VarCounter.hpp"
namespace Shell {
class Term;
class Formula;
class FormulaList;
class FormulaVarIterator
{
public:
  FormulaVarIterator (const Formula&);
  FormulaVarIterator (const FormulaList&);
  ~FormulaVarIterator ();
  bool hasNext ();
  Var next ();
private:
  class Element;
  Term* _current;
  Element* _reserve;
  VarCounter _bound;
  void popReserve ();
}; 
}
#endif 
