/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __FunctionDefinition__
#define __FunctionDefinition__
namespace Shell {
class Term;
class TermList;
class Atom;
class Clause;
class Formula;
class Problem;
class Signature;
class FunctionSymbol;
class UnitList;
class Literal;
class LiteralList;
class FunctionDefinition
{
public:
  FunctionDefinition (Problem&,const Signature &);
  ~FunctionDefinition ();
  int removeAllDefinitions ();
  static bool isFunctionDefinition (const Clause&);
  static bool isFunctionDefinition (const Clause&, Term& lhs, Term& rhs);
  static bool isFunctionDefinition (const Atom&, Term& lhs, Term& rhs);
  static bool isFunctionDefinition (const Formula&);
  static bool isFunctionDefinition (const Formula&, Term& lhs, Term& rhs);
private:
  class Def;
  static bool defines (const Term& t, const Term& lhs);
  static bool occurs (const FunctionSymbol&, const Term&);
  void count (const Clause& c);
  bool unfoldAllDefs ();
  bool unfold (Def& def);
  bool unfold (Term& t,UnitList& parents);
  bool unfold (TermList& t,UnitList& parents);
  void apply (LiteralList& ls,UnitList& parents);
  void apply (Literal& l,UnitList& parents);
  void apply (TermList& ls,UnitList& parents);
  void apply (Term& l,UnitList& parents);
  Problem& _problem;
  int _numberOfFunctions;
  Def* _defs;
  int* _counter;
  int _removed;
}; 
}
#endif
