/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "Allocator.hpp"
#include "DestructionMode.hpp"
#include "Environment.hpp"
#include "IntNameTable.hpp"
#include "Options.hpp"
#include "Map.hpp"
#include "Run.hpp"
#include "Signature.hpp"
#include "Tracer.hpp"
#include "Unit.hpp"
#include "XML.hpp"
using namespace Shell;
#if DEBUG_SHELL
string MyTracer::_lastControlPoint = "";
MyTracer* MyTracer::_current = 0;
long MyTracer::_passedControlPoints = 0L;
ControlPointKind MyTracer::_lastPointKind = CP_MID;
#endif
int MapConstants::capacities[] =
  { 0, 11, 29, 47, 89, 167, 277, 547, 1229, 2749, 6143, 12569, 
    26407, 48619, 93187, 187973,
    389173, 814309, 1712369, 3451241, 7368791, 17144507, 37667713,
    76918277, 141650963, 217645199,  0};
bool DestructionMode::_isFast = false;
#if DEBUG_SHELL
Debugger::Memory* Debugger::_allocatedPieces = Debugger::initialiseMemory();
#endif
const int IntNameTable::_noOfBuckets = 2039;
IntNameTable IntNameTable::vars;
string Formula::_connectiveNames[] =
  {"atomic", "and", "or", "imp", "iff", "xor", "not", "forall", "exists"};
Run* Run::_current;
#ifdef _MSC_VER
template<> Allocator<2>* Allocator<2>::_freeList = 0;
template<> Allocator<3>* Allocator<3>::_freeList = 0;
template<> Allocator<4>* Allocator<4>::_freeList = 0;
template<> Allocator<6>* Allocator<6>::_freeList = 0;
template<> Allocator<8>* Allocator<8>::_freeList = 0;
template<> Allocator<9>* Allocator<9>::_freeList = 0;
template<> Allocator<10>* Allocator<10>::_freeList = 0;
template<> Allocator<12>* Allocator<12>::_freeList = 0;
template<> Allocator<13>* Allocator<13>::_freeList = 0;
template<> Allocator<14>* Allocator<14>::_freeList = 0;
template<> Allocator<15>* Allocator<15>::_freeList = 0;
template<> Allocator<16>* Allocator<16>::_freeList = 0;
template<> Allocator<17>* Allocator<17>::_freeList = 0;
template<> Allocator<18>* Allocator<18>::_freeList = 0;
template<> Allocator<20>* Allocator<20>::_freeList = 0;
#else
template<> Allocator<1> * Allocator<1>::_freeList = 0;
template<> Allocator<2> * Allocator<2>::_freeList = 0;
template<> Allocator<3>* Allocator<3>::_freeList = 0;
template<> Allocator<4>* Allocator<4>::_freeList = 0;
template<> Allocator<6>* Allocator<6>::_freeList = 0;
template<> Allocator<7>* Allocator<7>::_freeList = 0;
template<> Allocator<8>* Allocator<8>::_freeList = 0;
template<> Allocator<9>* Allocator<9>::_freeList = 0;
template<> Allocator<10>* Allocator<10>::_freeList = 0;
#endif
Signature Signature::sig;
Environment::OptionsMap* Environment::OptionsMap::map = 
  new Environment::OptionsMap("$",new Options(),
  new Environment::OptionsMap("$default",new Options(),0));
Environment::OptionsMap* Environment::OptionsMap::active = 
  Environment::OptionsMap::map;
Environment::KnowledgeBase* Environment::KnowledgeBase::all =
  new Environment::KnowledgeBase("$",0);
