/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Matching__
#define __Matching__
#include "VarCounter.hpp"
namespace Shell {
class Substitution;
class Formula;
class FormulaList;
class Atom;
class Term;
class TermList;
class Matching
{
public:
  static bool match (const Formula&, const Formula&, Substitution& sbst);
private:
  Matching (Substitution& sbst) : _sbst(sbst) {}
  bool match (const Formula&, const Formula&);
  bool match (const FormulaList&,const FormulaList&);
  bool match (const Atom&, const Atom&);
  bool match (const Term&, const Term&);
  bool match (const TermList&, const TermList&);
  bool hasBoundVariables (const Term& t) const;
  VarCounter _bound1;
  VarCounter _bound2;
  Substitution& _sbst;
};
}
#endif 
