/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Naming__
#define __Naming__
#include "Calculator.hpp"
#include "Unit.hpp"
namespace Shell {
class Signature;
class Unit;
class Naming
{
public:
  Naming (int threshold, Signature& signature);
  const UnitList& getDefinitions() const { return _definitions; }
  void apply(Unit& unit);
private:
  struct ClsRep;
  enum Where {
    ON_TOP,
    UNDER_IFF,
    OTHER
  }; 
  int _threshold;
  Signature& _signature;
  UnitList _definitions;
  void apply(Formula& subformula,Where where,ClsRep&);
  bool apply(FormulaList& subformulas,Where where,Formula*,ClsRep*);
  static void arrayToList(FormulaList& writeTo,int length,Formula* array);
  static Formula* listToArray(FormulaList& fs,int length);
  void introduceDefinition(const Formula& f,Formula& name,bool iff);
  Calculator _calc;
  int iffConCls(const ClsRep& lhs,const ClsRep& rhs);
  int iffConRep(const ClsRep& lhs,const ClsRep& rhs);
  int iffDisCls(const ClsRep& lhs,const ClsRep& rhs);
  int iffDisRep(const ClsRep& lhs,const ClsRep& rhs);
}; 
}
#endif
