/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Permutation__
#define __Permutation__
#include "Compare.hpp"
namespace Shell {
class Term;
class TermList;
class Atom;
class Literal;
class LiteralList;
class Renaming;
class Permutation
{
public:
  static bool isPermutation(const LiteralList&, const LiteralList&);
  bool lessThan(const Literal& l1,const Literal& l2);
private:
  static bool match(const Term&, const Term&, Renaming&);
  static bool match(const TermList&, const TermList&, Renaming&);
  static bool match(const Atom&, const Atom&, bool swap, Renaming&);
  static bool permutation(Literal* ls1,Literal* ls2,
			  int ind1,int ind2,
			  bool swap, Renaming& ren);
  static Literal* sort(const LiteralList&,int length);
}; 
}
#endif 
