/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Position__
#define __Position__
#include "Lists.hpp"
#include <string>
namespace Shell {
class Formula;
class FormulaList;
class Position
  : public IntList
{
 public:
  Position ();
  Position (const Position&);
  explicit Position (int p); 
  Position (int head, const Position& tail);
  const Position& tail () const
    { return static_cast<const Position&>(IntList::tail()); }
  const Formula& subformula (const Formula&) const;
  int polarity (const Formula&) const;
  void replace (Formula& f, const Formula& g) const;
private:
  void replaceReverse (Formula& f, const Formula& g) const;
  void replaceReverse (FormulaList& fs, const Formula& g, int pos) const;
  int polarityReverse (const Formula&) const;
  int polarityReverse (int k,const FormulaList&) const;
}; 
class NonExistingPositionException {
};
inline
Position::Position () 
  : 
  IntList ()
{
} 
inline
Position::Position (const Position& ts)
  :
  IntList (ts)
{
} 
inline
Position::Position (int hd, const Position& tl)
  :
  IntList (hd,tl)
{
} 
inline
Position::Position (int hd)
  :
  IntList (hd)
{
} 
}
#endif 
