/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __RANDOM__
#  define __RANDOM__
#include <cstdlib>
#include <ctime>
class Random 
{
  static int _seed;             
  static int _remainingBits;    
  static const int _bitsPerInt; 
  static int _bits;             
  static int bitsPerInt ();     
 public:
  static int getMax ();
  static int getInteger ();
  static int getInteger (int modulus);
  static int getBit ();
  static void setSeed (int s);
  static int getSeed ();
  static void resetSeed ();
}; 
inline
void Random::setSeed ( int s )
{
  _seed = s;
  srand ( s );
}
inline
int Random::getSeed ()
{
  return _seed;
}
inline
int Random::getMax ()
{
  return RAND_MAX;
}
inline
int Random::getInteger ()
{
  return rand ();
}
inline
int Random::getInteger (int modulus)
{
  return getInteger () % modulus;
}
inline
void Random::resetSeed ()
{
  setSeed (time(0));
}
inline
int Random::getBit ()
{
  if ( _remainingBits == 0 ) {
    _remainingBits = _bitsPerInt;
    _bits = getInteger();
  }
  int result = _bits % 2;
  _bits /= 2;
  _remainingBits --;
  return result;
} 
#endif
