/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Rectify__
#define __Rectify__
#include "Substitution.hpp"
namespace Shell {
class Formula;
class Unit;
class VarList;
class FormulaList;
class Atom;
class Rectify 
{
public:
  static void rectify (Unit&);
private:
  void rectify (Formula&);
  void rectify (FormulaList&); 
  void rectify (Atom&);
  void rectify (TermList&);
  void rectify (Term&);
  void rectify (const VarList& vs, VarList& result);
  Substitution _subst;
  VarList _free;
}; 
}
#endif
