/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Refutation__
#  define __Refutation__
#include "Unit.hpp"
namespace Shell {
class Options;
class Kernel;
class Refutation
{
 public:
  Refutation (const Kernel& kernel, 
	      const Problem& problem,
	      const Options& options);
  const UnitList& refutation () const { return _refutation; }
  const Unit& goal () const { return _goal; }
  const Kernel& kernel () const { return _kernel; }
  const Problem& Refutation::problem () const { return _problem; } 
  XML::Element* toXML () const;
  void prettyPrint (ostream&,int answerNumber);
  void* operator new (size_t);
 private:
  class Map; 
  const Kernel& _kernel;
  const Problem& _problem;
  const Options& _options;
  UnitList _refutation;
  Unit _goal;
  bool _proofCheck;
  void collect (Unit&, Map& map);
  Unit collectKernelClause (const void* clause, Map& map);
  UnitList collectKernelClauseParents (const void* parents, Map& map);
}; 
}
#endif 
