/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Renaming__
#define __Renaming__
namespace Shell {
class Term;
class TermList;
class Atom;
class Literal;
class LiteralList;
class Clause;
class Renaming
{
public:
  Renaming(bool backtrack);
  ~Renaming();
  bool bind(int v1,int v2);
  bool undoBinding(int v1);
  int backtrackPoint() const { return _stackPos; }
  void backtrack(int point);
private:
  static void expandToFit(int v,int*& varArray,int& arrayLength);
  int* _direct;
  int* _inverse;
  int _nextDirect;
  int _nextInverse;
  bool _backtrack;
  int* _stack;
  int _stackCapacity;
  int _stackPos;
}; 
}
#endif 
