/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __ShellReader__
#define __ShellReader__
#include "Reader.hpp"
using namespace std;
namespace Shell {
class Reader 
  : public Vampire::Reader
{
protected:
  Vampire::TermTag tag(const Vampire::Term*) const;
  int var(const Vampire::Term*) const;
  const Vampire::FunctionSymbol* functor(const Vampire::Term*) const;
  string name(const Vampire::FunctionSymbol*) const;
  const Vampire::TermList* args(const Vampire::Term*) const;
  const VampireKernelEnvironment::InterpretedConstant* value(const Vampire::Term*) const;
  bool isEmpty(const Vampire::TermList* start,
	       const Vampire::TermList* end) const;
  const Vampire::Term* head(const Vampire::TermList*) const;
  const Vampire::TermList* tail(const Vampire::TermList* start,
				const Vampire::TermList* end) const;
  bool isEquality(const Vampire::Atom*) const;
  const Vampire::TermList* args(const Vampire::Atom*) const;
  const Vampire::PredicateSymbol* functor(const Vampire::Atom*) const;
  string name(const Vampire::PredicateSymbol*) const;
  bool isPositive(const Vampire::Literal*) const;
  const Vampire::Atom* atom(const Vampire::Literal*) const;
  bool isEmpty(const Vampire::LiteralList* start,
	       const Vampire::LiteralList* end) const;
  const Vampire::Literal* head(const Vampire::LiteralList*) const;
  const Vampire::LiteralList* tail(const Vampire::LiteralList* start,
				   const Vampire::LiteralList* end) const;
  const Vampire::LiteralList* literals(const Vampire::Clause*) const;
  int number(const Vampire::Unit*) const;
  const Vampire::Clause* clause(const Vampire::Unit*) const;
  const Vampire::Formula* formula(const Vampire::Unit*) const;
  const Vampire::UnitList* premises(const Vampire::Unit*) const;
  virtual bool isEmpty(const Vampire::UnitList* start,
		       const Vampire::UnitList* end) const;
  virtual const Vampire::Unit* head(const Vampire::UnitList*) const;
  virtual const Vampire::UnitList* tail(const Vampire::UnitList* start,
					const Vampire::UnitList* end) const;
  virtual void saveBackground(const Vampire::Unit*,Vampire::Background&) const;
};
}
#endif
