/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Skolem__
#define __Skolem__
#include "Substitution.hpp"
class Unit;
class Formula;
class FormulaList;
class Position;
class InferenceInfoTermList;
namespace Shell {
class Skolem
{
public:
  static void skolemise(Unit&);
private:
  Skolem () : _info(0) {}
  void skolemiseNNF(Formula&, 
		    const Position& pos,
		    const Position& posWithERemoved);
  void skolemiseNNF(FormulaList&, 
		    const Position& position,
		    const Position& posWithERemoved,
		    int pos);
  void makeSkolemTerms(const VarList& vars, 
		       const TermList& skolemArgs,
		       int arity,
		       TermList& skolemTerms);
  InferenceInfoTermList* _info;
  Substitution _subst;
}; 
}
#endif
