/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __TPTPLexer__
#define __TPTPLexer__
#include <iostream>
#include "Lexer.hpp"
using namespace std;
namespace Shell {
class TPTPLexer 
  : public Lexer
{
public:
  TPTPLexer(istream& in);
  void readToken (Token&);
  ~TPTPLexer () {}
private:
  enum CharType {
    UPPER_CASE_LETTER,
    LOWER_CASE_LETTER,
    DIGIT,
    SYMBOLIC,
    QUOTE,
    WHITE,
    SINGLE,
    OTHER
  };
  void skipWhiteSpacesAndComments();
  CharType currentCharacterType() const;
  void readName(Token&);
  void readSymbolic(Token&);
  void readSingle(Token&);
  void readQuotedString(Token&);
  TokenType detectNameTokenTypeOfLastToken();
  TokenType detectSymbolicTokenTypeOfLastToken();
}; 
}
#endif
