/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __TermVarIterator__
#define __TermVarIterator__
#include "Var.hpp"
namespace Shell {
class Term;
class TermList;
class Atom;
class Literal;
class TermVarIterator
{
public:
  TermVarIterator (const Term&);
  TermVarIterator (const TermList&);
  TermVarIterator (const Atom&);
  TermVarIterator (const Literal&);
  ~TermVarIterator ();
  bool hasNext ();
  Var next ();
private:
  class Element {
  public:
    Element (const TermList& list, Element* rest) 
      : _list(const_cast<TermList*>(&list)), _rest(rest) {}
    TermList* _list;
    Element* _rest;
  };
  Term* _current;
  Element* _reserve;
}; 
}
#endif 
