/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Token__
#define __Token__
#include <string>
namespace Shell {
enum TokenType {
  TT_INTEGER,
  TT_REAL,
  TT_LPAR,
  TT_RPAR,
  TT_LBRA,
  TT_RBRA,
  TT_COMMA,
  TT_COLON,
  TT_DOT,
  TT_AND,
  TT_NOT,
  TT_OR,
  TT_IFF,
  TT_IMP,
  TT_RIMP,
  TT_XOR,
  TT_FORALL,
  TT_EXISTS,
  TT_TRUE,
  TT_FALSE,
  TT_PP,
  TT_MM,
  TT_EQUAL,
  TT_NEQ,
  TT_NAME,
  TT_VAR,
  TT_INPUT_FORMULA, 
  TT_INPUT_CLAUSE,
  TT_CNF,
  TT_INCLUDE,
  TT_EOF,
  TT_ROW_VARIABLE,
  TT_STRING,
  TT_QUOTED_STRING,
  TT_GREATER_THAN,
  TT_LESS_THAN,
  TT_END_OF_EMPTY_TAG,
  TT_TEXT,
  TT_CLOSING_TAG
}; 
class Token 
{
public:
  TokenType tag;
  std::string text;
  int line;
  static std::string toString (TokenType);
};
}
#endif 
