/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "IUCommand.hpp"
using namespace std;
using namespace VK;
#ifndef NO_DEBUG_VIS
ostream& operator<<(ostream& str,IUCommand::Tag tag)
{
  switch (tag)
    {
    case IUCommand::Start: return str << "Start";
    case IUCommand::Var: return str << "Var"; 
    case IUCommand::VarFirstOcc: return str << "VarFirstOcc"; 
    case IUCommand::Func: return str << "Func"; 
    case IUCommand::FuncLinear: return str << "FuncLinear"; 
    case IUCommand::FuncGround: return str << "FuncGround"; 
    case IUCommand::Const: return str << "Const";
    case IUCommand::End: return str << "End"; 
    default: return str << "UNKNOWN IUCommand"; 
    };
};
ostream& IUCommand::output(ostream& str,const IUCommand* start) const
{
  str << '[' << this - start << "] " << tag();
  if (tag() == End) return str;
  str << ' ';
  Symbol().output(str); 
  if ((tag() == Func) || (tag() == FuncGround) || (tag() == FuncLinear))
    {
      str << " next = [" << NextCommand() - start << "] ";
      UnifTerm::outputTerm(str,Term());
    };
  if (tag() == Start) 
    {
      str << " variables = [" << (AllVars() ? (AllVars() - start) : 0) << "] ";
      UnifTerm::outputTerm(str,Term());
    }; 
  if (tag() == VarFirstOcc) 
    str << " next variable = [" << (NextVar() ? (NextVar() - start) : 0) << ']';
  return str;
}; 
ostream& IUCommand::outputCode(ostream& str) const
{
  const IUCommand* com;
  for (com = this; com->tag() != End; com++)
    com->output(str,this) << '\n';
  return com->output(str,this) << '\n';
}; 
#endif
