/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "LiteralList.hpp"
#include "LiteralProperties.inl"
using namespace BK;
using namespace VK;
ostream& LiteralList::output(ostream& str,bool showLiteralProperties)
{
 CALL("output(ostream& str,bool showLiteralProperties)");
 Iterator iter(this);
 ulong sel = numOfSelectedLits();
 for (ulong i = 0; i < sel; i++)
  {
   ASSERT(iter.notEnd());
   if (iter.currentElement()->properties().equalityOrientationMode() !=
       LiteralProperties::DefaultEqualityOrientation &&
       iter.currentLiteral()->IsEquality() && 
       iter.currentLiteral()->Positive())
     {
       str << *(iter.currentElement()->equalityLHS());
       if (iter.currentElement()->isOrientableEq())
	 {
	   if (iter.currentLiteral()->IsOrderedEq())
	     {
	       if (iter.currentElement()->orientationFollowsOrdering())
		 {
		   str << ":==";
		 }
	       else
		 {
		   str << ":=<";
		 };
	     }
	   else
	     str << ":=";
	 }
       else
	 str << "*=*";
       str << *(iter.currentElement()->equalityRHS());
     }
   else
     str << iter.currentLiteral();
   if (showLiteralProperties && 
       !iter.currentElement()->properties().isDefault()) 
     str << " <@["  << iter.currentElement()->properties() << "]";
   iter.next();       
   if (i + 1 < sel) str <<  " \\/ ";
  };  
 if (iter.notEnd()) str << " | ";
 while (iter.notEnd()) 
  { 
   str << iter.currentLiteral();
   if (showLiteralProperties && 
       !iter.currentElement()->properties().isDefault())
     {
       str << " <@[" << iter.currentElement()->properties() << "]";
     };
   iter.next();          
   if (iter.notEnd()) str << " \\/ ";
  };
 return str;
}; 
