/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef LITERAL_ORDERING_HPP
#define LITERAL_ORDERING_HPP
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "Comparison.hpp"
#include "TemporaryLiteral.hpp"
#undef DEBUG_NAMESPACE
#ifdef DEBUG_LITERAL_ORDERING
 #define DEBUG_NAMESPACE "LiteralOrdering"
#endif
#include "debugMacros.hpp"
namespace VK
{
  class LiteralOrdering
  {
  public:
    LiteralOrdering() : _isStratified(false) {};
    virtual ~LiteralOrdering();
    bool isStratified() const { return _isStratified; };
    virtual 
    BK::Comparison compare(TemporaryLiteral& lit1,
			   TemporaryLiteral& lit2) const = 0;
    virtual
    BK::Comparison compareLayers(const TemporaryLiteral& lit1,
				 const TemporaryLiteral& lit2) const = 0;
  protected:
    bool _isStratified;
  }; 
}; 
#endif
