/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "TemporaryClause.hpp"
#include "Clause.inl"
using namespace BK;
using namespace VK;
TemporaryClause::Context* TemporaryClause::Context::_current; 
#undef DEBUG_NAMESPACE
#ifdef DEBUG_TEMPORARY_CLAUSE
#  define DEBUG_NAMESPACE "TemporaryClause"
#endif
#include "debugMacros.hpp"
TemporaryClause::TemporaryClause() 
{    
};
TemporaryClause::~TemporaryClause()
{
  CALL("destructor ~TemporaryClause()");
}; 
void TemporaryClause::reset()
{
  CALL("reset()");
  TempLitListExtras::freshList(_literals);
  _background.Reset();
  _universalId = Context::getCurrent()->generateUniversalId();
}; 
ostream& TemporaryClause::outputAnnounced(ostream& str) const
{
  CALL("output(ostream& str) const");
  str << "ANN " << _universalId << " ..... ";  
  ClauseBackground::outputRules(str << '[',_background.Rules());
  for (const Ancestor* anc = _background.end(); 
       anc > _background.begin(); 
       )
    {
      --anc;
      str << anc->strip()->Number() << ' '; 
    };
  str << " ...]";
  return str;
}; 
ostream& TemporaryClause::outputComplete(ostream& str) const
{
  CALL("output(ostream& str) const");
  _literals->output(str << "GEN " << _universalId << " ");
  ClauseBackground::outputRules(str << '[',_background.Rules());
  for (const Ancestor* anc = _background.end(); 
       anc > _background.begin(); 
       )
    {
      --anc;
      str << anc->strip()->Number() << ' '; 
    };
  str << ']';  
  return str;
}; 
