/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "Unifier.hpp"
#undef DEBUG_NAMESPACE
#ifdef DEBUG_UNIFIER
#  define DEBUG_NAMESPACE "Variable"
#endif
#include "debugMacros.hpp"
using namespace VK;
long Unifier::InitStatic::_count; 
Unifier* Unifier::_current;
ulong Unifier::_offsetForIndex[VampireKernelConst::MaxNumOfIndices];
ostream& Unifier::Variable::output(ostream& str) const
{
  ulong num;
  ulong index;
  NumAndIndex(num,index);    
  return str << 'X' << num << '{' << index << '}';
}; 
#ifndef NO_DEBUG_VIS
ostream& Unifier::Variable::outputBinding(ostream& str,ostream& (*outputTerm)(ostream& str,const UnifTerm* t)) const
{ 
  output(str) << " := ";
  if (!Binding()) return str << "NULL"; 
  if (Unifier::current()->isVariable(Binding()))
    return (static_cast<const Unifier::Variable*>(Binding()))->output(str);
  return outputTerm(str,static_cast<const UnifTerm*>(Binding()));
}; 
#endif
#undef DEBUG_NAMESPACE
#ifdef DEBUG_UNIFIER
 #define DEBUG_NAMESPACE "Unifier"
#endif
#include "debugMacros.hpp"
Unifier::Unifier() 
{
  CALL("constructor Unifier()");
  next = bound;
  next_section = section;
  _endOfVariableBank = 
    _variableBank + 
    VampireKernelConst::MaxNumOfIndices*VampireKernelConst::MaxNumOfVariables;
}; 
Unifier::~Unifier() { CALL("destructor ~Unifier()"); };
#ifndef NO_DEBUG_VIS
ostream& Unifier::output(ostream& str,ostream& (*outputTerm)(ostream& str,const UnifTerm* t)) const
{ 
  for(const Unifier::Variable* const * p = bound; p<next; p++)
    (*p)->outputBinding(str,outputTerm) << '\n'; 
  return str;        
}; 
#endif
#undef DEBUG_NAMESPACE
#ifdef DEBUG_UNIFIER
 #define DEBUG_NAMESPACE "Unifier::Variable::RenamingToInt"
#endif
#include "debugMacros.hpp"
#ifndef NO_DEBUG_VIS
ostream& Unifier::Variable::RenamingToInt::output(ostream& str) const
{
  str << "Unifier::Variable::RenamingToInt:\n";
  for (const Unifier::Variable* const * r = renamed; r < next; r++)
    (*r)->output(str) << " -> " << _renaming[(*r)->absoluteVarNum()] << '\n';
  return str << "END OF Unifier::Variable::RenamingToInt.\n";
}; 
#endif
