/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef VAMPIRE_KERNEL_ENVIRONMENT_HPP
#define VAMPIRE_KERNEL_ENVIRONMENT_HPP
#include <string>
#include <new>
namespace VampireKernelEnvironment
{
  class InterpretedConstant
  {
  public:
    InterpretedConstant() { _implementation = 0; }
    explicit InterpretedConstant(void* value);
    ~InterpretedConstant();
    InterpretedConstant(const InterpretedConstant& f);
    void erase() {
      this->~InterpretedConstant();
      ::new (static_cast<void*>(this)) InterpretedConstant();
    };
    void operator=(const InterpretedConstant& rhs);
    int compare(const InterpretedConstant& c) const; 
    bool equals(const InterpretedConstant& c) const
      { return compare(c) == 0; }
    void useAsNextArgument() const;
    static bool evaluateFunction(int functionNumber,
				 InterpretedConstant& result);
    static bool evaluatePredicate(int predicateNumber,
				  bool& result);
    std::string toString() const;
  protected:
    void* _implementation;
  }; 
}; 
#endif
