/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __VarCounter__
#define __VarCounter__
#include "Var.hpp"
#include "XML.hpp"
namespace Shell {
class VarCounter
{
public:
  VarCounter ();
  ~VarCounter ();
  void incCount (Var v);
  void decCount (Var v);
  void setCount (Var v, int count);
  int getCount (Var v) const;
  XML::Element* toXML () const;
private:
  int _top;
  int* _counts;
  void expandToFit (int v);
}; 
}
#endif 
