/**
 * Copyright (c) 2006 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-J3.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "TheoryFinder.hpp"
namespace Shell {
void TheoryFinder::addTheory ()
{
  TermList termList0;
  LiteralList literalList0;
  Term term1(Var(3));
  Term term2(Var(4));
  TermList termList3(term2,termList0);
  TermList termList4(term1,termList3);
  PredicateSymbol& pred1 = _sig.createPred("left_identity",2);
  Atom atom5(pred1,termList4);
  Literal literal6(false,atom5);
  Term term7(Var(3));
  TermList termList8(term7,termList0);
  PredicateSymbol& pred2 = _sig.createPred("associativity",1);
  Atom atom9(pred2,termList8);
  Literal literal10(false,atom9);
  Term term11(Var(3));
  Term term12(Var(4));
  TermList termList13(term12,termList0);
  TermList termList14(term11,termList13);
  PredicateSymbol& pred3 = _sig.createPred("left_monoid",2);
  Atom atom15(pred3,termList14);
  Literal literal16(true,atom15);
  LiteralList literalList17(literal16,literalList0);
  LiteralList literalList18(literal10,literalList17);
  LiteralList literalList19(literal6,literalList18);
  Clause clause20(literalList19);
  _metaTheory.push(Unit("ax20",AXIOM,clause20));
  Term term21(Var(3));
  Term term22(Var(4));
  TermList termList23(term22,termList0);
  TermList termList24(term21,termList23);
  PredicateSymbol& pred4 = _sig.createPred("right_identity",2);
  Atom atom25(pred4,termList24);
  Literal literal26(false,atom25);
  Term term27(Var(3));
  TermList termList28(term27,termList0);
  Atom atom29(pred2,termList28);
  Literal literal30(false,atom29);
  Term term31(Var(3));
  Term term32(Var(4));
  TermList termList33(term32,termList0);
  TermList termList34(term31,termList33);
  PredicateSymbol& pred5 = _sig.createPred("right_monoid",2);
  Atom atom35(pred5,termList34);
  Literal literal36(true,atom35);
  LiteralList literalList37(literal36,literalList0);
  LiteralList literalList38(literal30,literalList37);
  LiteralList literalList39(literal26,literalList38);
  Clause clause40(literalList39);
  _metaTheory.push(Unit("ax40",AXIOM,clause40));
  Term term41(Var(3));
  Term term42(Var(4));
  TermList termList43(term42,termList0);
  TermList termList44(term41,termList43);
  Atom atom45(pred5,termList44);
  Literal literal46(false,atom45);
  Term term47(Var(3));
  Term term48(Var(5));
  Term term49(Var(4));
  TermList termList50(term49,termList0);
  TermList termList51(term48,termList50);
  TermList termList52(term47,termList51);
  PredicateSymbol& pred6 = _sig.createPred("right_inverse",3);
  Atom atom53(pred6,termList52);
  Literal literal54(false,atom53);
  Term term55(Var(3));
  Term term56(Var(5));
  Term term57(Var(4));
  TermList termList58(term57,termList0);
  TermList termList59(term56,termList58);
  TermList termList60(term55,termList59);
  PredicateSymbol& pred7 = _sig.createPred("group",3);
  Atom atom61(pred7,termList60);
  Literal literal62(true,atom61);
  LiteralList literalList63(literal62,literalList0);
  LiteralList literalList64(literal54,literalList63);
  LiteralList literalList65(literal46,literalList64);
  Clause clause66(literalList65);
  _metaTheory.push(Unit("ax66",AXIOM,clause66));
  Term term67(Var(3));
  Term term68(Var(4));
  TermList termList69(term68,termList0);
  TermList termList70(term67,termList69);
  Atom atom71(pred3,termList70);
  Literal literal72(false,atom71);
  Term term73(Var(3));
  Term term74(Var(5));
  Term term75(Var(4));
  TermList termList76(term75,termList0);
  TermList termList77(term74,termList76);
  TermList termList78(term73,termList77);
  PredicateSymbol& pred8 = _sig.createPred("left_inverse",3);
  Atom atom79(pred8,termList78);
  Literal literal80(false,atom79);
  Term term81(Var(3));
  Term term82(Var(5));
  Term term83(Var(4));
  TermList termList84(term83,termList0);
  TermList termList85(term82,termList84);
  TermList termList86(term81,termList85);
  Atom atom87(pred7,termList86);
  Literal literal88(true,atom87);
  LiteralList literalList89(literal88,literalList0);
  LiteralList literalList90(literal80,literalList89);
  LiteralList literalList91(literal72,literalList90);
  Clause clause92(literalList91);
  _metaTheory.push(Unit("ax92",AXIOM,clause92));
  Term term93(Var(3));
  Term term94(Var(5));
  Term term95(Var(4));
  TermList termList96(term95,termList0);
  TermList termList97(term94,termList96);
  TermList termList98(term93,termList97);
  Atom atom99(pred7,termList98);
  Literal literal100(false,atom99);
  Term term101(Var(3));
  TermList termList102(term101,termList0);
  PredicateSymbol& pred9 = _sig.createPred("commutativity",1);
  Atom atom103(pred9,termList102);
  Literal literal104(false,atom103);
  Term term105(Var(3));
  Term term106(Var(5));
  Term term107(Var(4));
  TermList termList108(term107,termList0);
  TermList termList109(term106,termList108);
  TermList termList110(term105,termList109);
  PredicateSymbol& pred10 = _sig.createPred("abelian_group",3);
  Atom atom111(pred10,termList110);
  Literal literal112(true,atom111);
  LiteralList literalList113(literal112,literalList0);
  LiteralList literalList114(literal104,literalList113);
  LiteralList literalList115(literal100,literalList114);
  Clause clause116(literalList115);
  _metaTheory.push(Unit("ax116",AXIOM,clause116));
  Term term117(Var(6));
  Term term118(Var(5));
  Term term119(Var(4));
  TermList termList120(term119,termList0);
  TermList termList121(term118,termList120);
  TermList termList122(term117,termList121);
  Atom atom123(pred10,termList122);
  Literal literal124(false,atom123);
  Term term125(Var(3));
  Term term126(Var(6));
  TermList termList127(term126,termList0);
  TermList termList128(term125,termList127);
  PredicateSymbol& pred11 = _sig.createPred("left_distributivity",2);
  Atom atom129(pred11,termList128);
  Literal literal130(false,atom129);
  Term term131(Var(3));
  Term term132(Var(6));
  TermList termList133(term132,termList0);
  TermList termList134(term131,termList133);
  PredicateSymbol& pred12 = _sig.createPred("right_distributivity",2);
  Atom atom135(pred12,termList134);
  Literal literal136(false,atom135);
  Term term137(Var(6));
  Term term138(Var(5));
  Term term139(Var(4));
  Term term140(Var(3));
  TermList termList141(term140,termList0);
  TermList termList142(term139,termList141);
  TermList termList143(term138,termList142);
  TermList termList144(term137,termList143);
  PredicateSymbol& pred13 = _sig.createPred("ringoid",4);
  Atom atom145(pred13,termList144);
  Literal literal146(true,atom145);
  LiteralList literalList147(literal146,literalList0);
  LiteralList literalList148(literal136,literalList147);
  LiteralList literalList149(literal130,literalList148);
  LiteralList literalList150(literal124,literalList149);
  Clause clause151(literalList150);
  _metaTheory.push(Unit("ax151",AXIOM,clause151));
  Term term152(Var(6));
  TermList termList153(term152,termList0);
  Atom atom154(pred2,termList153);
  Literal literal155(false,atom154);
  Term term156(Var(6));
  TermList termList157(term156,termList0);
  Atom atom158(pred9,termList157);
  Literal literal159(false,atom158);
  Term term160(Var(6));
  TermList termList161(term160,termList0);
  PredicateSymbol& pred14 = _sig.createPred("ac",1);
  Atom atom162(pred14,termList161);
  Literal literal163(true,atom162);
  LiteralList literalList164(literal163,literalList0);
  LiteralList literalList165(literal159,literalList164);
  LiteralList literalList166(literal155,literalList165);
  Clause clause167(literalList166);
  _metaTheory.push(Unit("ax167",AXIOM,clause167));
  Term term168(Var(6));
  TermList termList169(term168,termList0);
  Atom atom170(pred14,termList169);
  Literal literal171(false,atom170);
  Term term172(Var(6));
  TermList termList173(term172,termList0);
  PredicateSymbol& pred15 = _sig.createPred("idempotence",1);
  Atom atom174(pred15,termList173);
  Literal literal175(false,atom174);
  Term term176(Var(6));
  TermList termList177(term176,termList0);
  PredicateSymbol& pred16 = _sig.createPred("aci",1);
  Atom atom178(pred16,termList177);
  Literal literal179(true,atom178);
  LiteralList literalList180(literal179,literalList0);
  LiteralList literalList181(literal175,literalList180);
  LiteralList literalList182(literal171,literalList181);
  Clause clause183(literalList182);
  _metaTheory.push(Unit("ax183",AXIOM,clause183));
  Term term184(Var(7));
  TermList termList185(term184,termList0);
  Atom atom186(pred16,termList185);
  Literal literal187(false,atom186);
  Term term188(Var(8));
  TermList termList189(term188,termList0);
  Atom atom190(pred16,termList189);
  Literal literal191(false,atom190);
  Term term192(Var(7));
  Term term193(Var(8));
  TermList termList194(term193,termList0);
  TermList termList195(term192,termList194);
  PredicateSymbol& pred17 = _sig.createPred("absorption",2);
  Atom atom196(pred17,termList195);
  Literal literal197(false,atom196);
  Term term198(Var(8));
  Term term199(Var(7));
  TermList termList200(term199,termList0);
  TermList termList201(term198,termList200);
  Atom atom202(pred17,termList201);
  Literal literal203(false,atom202);
  Term term204(Var(7));
  Term term205(Var(8));
  TermList termList206(term205,termList0);
  TermList termList207(term204,termList206);
  PredicateSymbol& pred18 = _sig.createPred("lattice",2);
  Atom atom208(pred18,termList207);
  Literal literal209(true,atom208);
  LiteralList literalList210(literal209,literalList0);
  LiteralList literalList211(literal203,literalList210);
  LiteralList literalList212(literal197,literalList211);
  LiteralList literalList213(literal191,literalList212);
  LiteralList literalList214(literal187,literalList213);
  Clause clause215(literalList214);
  _metaTheory.push(Unit("ax215",AXIOM,clause215));
  Term term216(Var(3));
  Term term217(Var(6));
  TermList termList218(term217,termList0);
  TermList termList219(term216,termList218);
  Atom atom220(pred11,termList219);
  Literal literal221(false,atom220);
  Term term222(Var(3));
  Term term223(Var(6));
  TermList termList224(term223,termList0);
  TermList termList225(term222,termList224);
  PredicateSymbol& pred19 = _sig.createPred("distributivity",2);
  Atom atom226(pred19,termList225);
  Literal literal227(true,atom226);
  LiteralList literalList228(literal227,literalList0);
  LiteralList literalList229(literal221,literalList228);
  Clause clause230(literalList229);
  _metaTheory.push(Unit("ax230",AXIOM,clause230));
  Term term231(Var(3));
  Term term232(Var(6));
  TermList termList233(term232,termList0);
  TermList termList234(term231,termList233);
  Atom atom235(pred12,termList234);
  Literal literal236(false,atom235);
  Term term237(Var(3));
  Term term238(Var(6));
  TermList termList239(term238,termList0);
  TermList termList240(term237,termList239);
  Atom atom241(pred19,termList240);
  Literal literal242(true,atom241);
  LiteralList literalList243(literal242,literalList0);
  LiteralList literalList244(literal236,literalList243);
  Clause clause245(literalList244);
  _metaTheory.push(Unit("ax245",AXIOM,clause245));
  Term term246(Var(7));
  Term term247(Var(8));
  TermList termList248(term247,termList0);
  TermList termList249(term246,termList248);
  Atom atom250(pred18,termList249);
  Literal literal251(false,atom250);
  Term term252(Var(7));
  Term term253(Var(8));
  TermList termList254(term253,termList0);
  TermList termList255(term252,termList254);
  Atom atom256(pred19,termList255);
  Literal literal257(false,atom256);
  Term term258(Var(7));
  Term term259(Var(8));
  TermList termList260(term259,termList0);
  TermList termList261(term258,termList260);
  PredicateSymbol& pred20 = _sig.createPred("distributive_lattice",2);
  Atom atom262(pred20,termList261);
  Literal literal263(true,atom262);
  LiteralList literalList264(literal263,literalList0);
  LiteralList literalList265(literal257,literalList264);
  LiteralList literalList266(literal251,literalList265);
  Clause clause267(literalList266);
  _metaTheory.push(Unit("ax267",AXIOM,clause267));
  Term term268(Var(3));
  Term term269(Var(4));
  TermList termList270(term269,termList0);
  TermList termList271(term268,termList270);
  Atom atom272(pred1,termList271);
  Literal literal273(false,atom272);
  Term term274(Var(3));
  Term term275(Var(4));
  TermList termList276(term275,termList0);
  TermList termList277(term274,termList276);
  PredicateSymbol& pred21 = _sig.createPred("identity",2);
  Atom atom278(pred21,termList277);
  Literal literal279(true,atom278);
  LiteralList literalList280(literal279,literalList0);
  LiteralList literalList281(literal273,literalList280);
  Clause clause282(literalList281);
  _metaTheory.push(Unit("ax282",AXIOM,clause282));
  Term term283(Var(3));
  Term term284(Var(4));
  TermList termList285(term284,termList0);
  TermList termList286(term283,termList285);
  Atom atom287(pred4,termList286);
  Literal literal288(false,atom287);
  Term term289(Var(3));
  Term term290(Var(4));
  TermList termList291(term290,termList0);
  TermList termList292(term289,termList291);
  Atom atom293(pred21,termList292);
  Literal literal294(true,atom293);
  LiteralList literalList295(literal294,literalList0);
  LiteralList literalList296(literal288,literalList295);
  Clause clause297(literalList296);
  _metaTheory.push(Unit("ax297",AXIOM,clause297));
  Term term298(Var(3));
  Term term299(Var(5));
  Term term300(Var(4));
  TermList termList301(term300,termList0);
  TermList termList302(term299,termList301);
  TermList termList303(term298,termList302);
  Atom atom304(pred8,termList303);
  Literal literal305(false,atom304);
  Term term306(Var(3));
  Term term307(Var(5));
  Term term308(Var(4));
  TermList termList309(term308,termList0);
  TermList termList310(term307,termList309);
  TermList termList311(term306,termList310);
  PredicateSymbol& pred22 = _sig.createPred("inverse",3);
  Atom atom312(pred22,termList311);
  Literal literal313(true,atom312);
  LiteralList literalList314(literal313,literalList0);
  LiteralList literalList315(literal305,literalList314);
  Clause clause316(literalList315);
  _metaTheory.push(Unit("ax316",AXIOM,clause316));
  Term term317(Var(3));
  Term term318(Var(5));
  Term term319(Var(4));
  TermList termList320(term319,termList0);
  TermList termList321(term318,termList320);
  TermList termList322(term317,termList321);
  Atom atom323(pred6,termList322);
  Literal literal324(false,atom323);
  Term term325(Var(3));
  Term term326(Var(5));
  Term term327(Var(4));
  TermList termList328(term327,termList0);
  TermList termList329(term326,termList328);
  TermList termList330(term325,termList329);
  Atom atom331(pred22,termList330);
  Literal literal332(true,atom331);
  LiteralList literalList333(literal332,literalList0);
  LiteralList literalList334(literal324,literalList333);
  Clause clause335(literalList334);
  _metaTheory.push(Unit("ax335",AXIOM,clause335));
  Term term336(Var(3));
  Term term337(Var(5));
  Term term338(Var(4));
  TermList termList339(term338,termList0);
  TermList termList340(term337,termList339);
  TermList termList341(term336,termList340);
  Atom atom342(pred7,termList341);
  Literal literal343(false,atom342);
  Term term344(Var(3));
  Term term345(Var(5));
  Term term346(Var(4));
  TermList termList347(term346,termList0);
  TermList termList348(term345,termList347);
  TermList termList349(term344,termList348);
  FunctionSymbol& fun5 = _sig.createFun("group",3);
  Term term350(fun5,termList349);
  TermList termList351(term350,termList0);
  PredicateSymbol& pred23 = _sig.createPred("answer",1);
  Atom atom352(pred23,termList351);
  Literal literal353(true,atom352);
  LiteralList literalList354(literal353,literalList0);
  LiteralList literalList355(literal343,literalList354);
  Clause clause356(literalList355);
  _metaTheory.push(Unit("ax356",AXIOM,clause356));
  Term term357(Var(6));
  Term term358(Var(5));
  Term term359(Var(4));
  Term term360(Var(3));
  TermList termList361(term360,termList0);
  TermList termList362(term359,termList361);
  TermList termList363(term358,termList362);
  TermList termList364(term357,termList363);
  Atom atom365(pred13,termList364);
  Literal literal366(false,atom365);
  Term term367(Var(3));
  TermList termList368(term367,termList0);
  Atom atom369(pred2,termList368);
  Literal literal370(false,atom369);
  Term term371(Var(6));
  Term term372(Var(5));
  Term term373(Var(4));
  Term term374(Var(3));
  TermList termList375(term374,termList0);
  TermList termList376(term373,termList375);
  TermList termList377(term372,termList376);
  TermList termList378(term371,termList377);
  FunctionSymbol& fun6 = _sig.createFun("ring",4);
  Term term379(fun6,termList378);
  TermList termList380(term379,termList0);
  Atom atom381(pred23,termList380);
  Literal literal382(true,atom381);
  LiteralList literalList383(literal382,literalList0);
  LiteralList literalList384(literal370,literalList383);
  LiteralList literalList385(literal366,literalList384);
  Clause clause386(literalList385);
  _metaTheory.push(Unit("ax386",AXIOM,clause386));
  Term term387(Var(6));
  TermList termList388(term387,termList0);
  Atom atom389(pred14,termList388);
  Literal literal390(false,atom389);
  Term term391(Var(9));
  Term term392(Var(6));
  TermList termList393(term392,termList0);
  TermList termList394(term391,termList393);
  PredicateSymbol& pred24 = _sig.createPred("robbins",2);
  Atom atom395(pred24,termList394);
  Literal literal396(false,atom395);
  Term term397(Var(9));
  Term term398(Var(6));
  TermList termList399(term398,termList0);
  TermList termList400(term397,termList399);
  FunctionSymbol& fun7 = _sig.createFun("robbins_algebra",2);
  Term term401(fun7,termList400);
  TermList termList402(term401,termList0);
  Atom atom403(pred23,termList402);
  Literal literal404(true,atom403);
  LiteralList literalList405(literal404,literalList0);
  LiteralList literalList406(literal396,literalList405);
  LiteralList literalList407(literal390,literalList406);
  Clause clause408(literalList407);
  _metaTheory.push(Unit("ax408",AXIOM,clause408));
  Term term409(Var(6));
  Term term410(Var(5));
  Term term411(Var(4));
  Term term412(Var(3));
  TermList termList413(term412,termList0);
  TermList termList414(term411,termList413);
  TermList termList415(term410,termList414);
  TermList termList416(term409,termList415);
  Atom atom417(pred13,termList416);
  Literal literal418(false,atom417);
  Term term419(Var(3));
  TermList termList420(term419,termList0);
  PredicateSymbol& pred25 = _sig.createPred("alternative",1);
  Atom atom421(pred25,termList420);
  Literal literal422(false,atom421);
  Term term423(Var(10));
  Term term424(Var(6));
  Term term425(Var(3));
  Term term426(Var(5));
  TermList termList427(term426,termList0);
  TermList termList428(term425,termList427);
  TermList termList429(term424,termList428);
  TermList termList430(term423,termList429);
  PredicateSymbol& pred26 = _sig.createPred("associator",4);
  Atom atom431(pred26,termList430);
  Literal literal432(false,atom431);
  Term term433(Var(6));
  Term term434(Var(5));
  Term term435(Var(4));
  Term term436(Var(3));
  Term term437(Var(10));
  TermList termList438(term437,termList0);
  TermList termList439(term436,termList438);
  TermList termList440(term435,termList439);
  TermList termList441(term434,termList440);
  TermList termList442(term433,termList441);
  FunctionSymbol& fun8 = _sig.createFun("non_associative_ring",5);
  Term term443(fun8,termList442);
  TermList termList444(term443,termList0);
  Atom atom445(pred23,termList444);
  Literal literal446(true,atom445);
  LiteralList literalList447(literal446,literalList0);
  LiteralList literalList448(literal432,literalList447);
  LiteralList literalList449(literal422,literalList448);
  LiteralList literalList450(literal418,literalList449);
  Clause clause451(literalList450);
  _metaTheory.push(Unit("ax451",AXIOM,clause451));
  Term term452(Var(11));
  TermList termList453(term452,termList0);
  Atom atom454(pred9,termList453);
  Literal literal455(false,atom454);
  Term term456(Var(3));
  TermList termList457(term456,termList0);
  Atom atom458(pred9,termList457);
  Literal literal459(false,atom458);
  Term term460(Var(11));
  Term term461(Var(3));
  TermList termList462(term461,termList0);
  TermList termList463(term460,termList462);
  Atom atom464(pred19,termList463);
  Literal literal465(false,atom464);
  Term term466(Var(3));
  Term term467(Var(11));
  TermList termList468(term467,termList0);
  TermList termList469(term466,termList468);
  Atom atom470(pred19,termList469);
  Literal literal471(false,atom470);
  Term term472(Var(11));
  Term term473(Var(12));
  TermList termList474(term473,termList0);
  TermList termList475(term472,termList474);
  Atom atom476(pred21,termList475);
  Literal literal477(false,atom476);
  Term term478(Var(3));
  Term term479(Var(13));
  TermList termList480(term479,termList0);
  TermList termList481(term478,termList480);
  Atom atom482(pred21,termList481);
  Literal literal483(false,atom482);
  Term term484(Var(11));
  Term term485(Var(5));
  Term term486(Var(13));
  TermList termList487(term486,termList0);
  TermList termList488(term485,termList487);
  TermList termList489(term484,termList488);
  Atom atom490(pred22,termList489);
  Literal literal491(false,atom490);
  Term term492(Var(3));
  Term term493(Var(5));
  Term term494(Var(12));
  TermList termList495(term494,termList0);
  TermList termList496(term493,termList495);
  TermList termList497(term492,termList496);
  Atom atom498(pred22,termList497);
  Literal literal499(false,atom498);
  Term term500(Var(11));
  Term term501(Var(3));
  Term term502(Var(5));
  Term term503(Var(12));
  Term term504(Var(13));
  TermList termList505(term504,termList0);
  TermList termList506(term503,termList505);
  TermList termList507(term502,termList506);
  TermList termList508(term501,termList507);
  TermList termList509(term500,termList508);
  FunctionSymbol& fun9 = _sig.createFun("boolean_algebra",5);
  Term term510(fun9,termList509);
  TermList termList511(term510,termList0);
  Atom atom512(pred23,termList511);
  Literal literal513(true,atom512);
  LiteralList literalList514(literal513,literalList0);
  LiteralList literalList515(literal499,literalList514);
  LiteralList literalList516(literal491,literalList515);
  LiteralList literalList517(literal483,literalList516);
  LiteralList literalList518(literal477,literalList517);
  LiteralList literalList519(literal471,literalList518);
  LiteralList literalList520(literal465,literalList519);
  LiteralList literalList521(literal459,literalList520);
  LiteralList literalList522(literal455,literalList521);
  Clause clause523(literalList522);
  _metaTheory.push(Unit("ax523",AXIOM,clause523));
  Term term524(Var(7));
  Term term525(Var(8));
  TermList termList526(term525,termList0);
  TermList termList527(term524,termList526);
  Atom atom528(pred18,termList527);
  Literal literal529(false,atom528);
  Term term530(Var(7));
  Term term531(Var(8));
  TermList termList532(term531,termList0);
  TermList termList533(term530,termList532);
  FunctionSymbol& fun10 = _sig.createFun("lattice",2);
  Term term534(fun10,termList533);
  TermList termList535(term534,termList0);
  Atom atom536(pred23,termList535);
  Literal literal537(true,atom536);
  LiteralList literalList538(literal537,literalList0);
  LiteralList literalList539(literal529,literalList538);
  Clause clause540(literalList539);
  _metaTheory.push(Unit("ax540",AXIOM,clause540));
  Term term541(Var(3));
  Term term542(Var(5));
  Term term543(Var(4));
  TermList termList544(term543,termList0);
  TermList termList545(term542,termList544);
  TermList termList546(term541,termList545);
  Atom atom547(pred7,termList546);
  Literal literal548(false,atom547);
  Term term549(Var(7));
  Term term550(Var(8));
  TermList termList551(term550,termList0);
  TermList termList552(term549,termList551);
  Atom atom553(pred18,termList552);
  Literal literal554(false,atom553);
  Term term555(Var(3));
  Term term556(Var(7));
  TermList termList557(term556,termList0);
  TermList termList558(term555,termList557);
  Atom atom559(pred11,termList558);
  Literal literal560(false,atom559);
  Term term561(Var(3));
  Term term562(Var(7));
  TermList termList563(term562,termList0);
  TermList termList564(term561,termList563);
  Atom atom565(pred12,termList564);
  Literal literal566(false,atom565);
  Term term567(Var(3));
  Term term568(Var(8));
  TermList termList569(term568,termList0);
  TermList termList570(term567,termList569);
  Atom atom571(pred11,termList570);
  Literal literal572(false,atom571);
  Term term573(Var(3));
  Term term574(Var(8));
  TermList termList575(term574,termList0);
  TermList termList576(term573,termList575);
  Atom atom577(pred12,termList576);
  Literal literal578(false,atom577);
  Term term579(Var(3));
  Term term580(Var(5));
  Term term581(Var(4));
  Term term582(Var(7));
  Term term583(Var(8));
  TermList termList584(term583,termList0);
  TermList termList585(term582,termList584);
  TermList termList586(term581,termList585);
  TermList termList587(term580,termList586);
  TermList termList588(term579,termList587);
  FunctionSymbol& fun11 = _sig.createFun("lattice_ordered_group",5);
  Term term589(fun11,termList588);
  TermList termList590(term589,termList0);
  Atom atom591(pred23,termList590);
  Literal literal592(true,atom591);
  LiteralList literalList593(literal592,literalList0);
  LiteralList literalList594(literal578,literalList593);
  LiteralList literalList595(literal572,literalList594);
  LiteralList literalList596(literal566,literalList595);
  LiteralList literalList597(literal560,literalList596);
  LiteralList literalList598(literal554,literalList597);
  LiteralList literalList599(literal548,literalList598);
  Clause clause600(literalList599);
  _metaTheory.push(Unit("ax600",AXIOM,clause600));
} 
}
