/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "Allocator.hpp"
#include "Property.hpp"
#include "Unit.hpp"
#include "XML.hpp"
#include "VampireException.hpp"
#include "Tracer.hpp"
using namespace Shell;
#define CHUNK_SIZE 1023
int GlobalAllocator::_remainingPieces = 0;
GlobalAllocator::Dummy* GlobalAllocator::_free = 0;
size_t GlobalAllocator::_totalNumberOfBytesAllocated = 0;
size_t GlobalAllocator::_memoryLimitInBytes = 0;
bool GlobalAllocator::_overflown = false;
#if DEBUG_SHELL
void* GlobalAllocator::allocate (int words, const string& className)
#else
void* GlobalAllocator::allocate (int words)
#endif
{
  ASS(CHUNK_SIZE >= words);
  if (_remainingPieces < words) {
    _free = new Dummy[CHUNK_SIZE];
    if (! _free) {
      ALLOCATION_FAILURE;
    }
    _totalNumberOfBytesAllocated += CHUNK_SIZE * sizeof(Dummy);
    if (! _overflown && _memoryLimitInBytes &&
	_memoryLimitInBytes < _totalNumberOfBytesAllocated) {
      _overflown = true;
      VAMPIRE_TERMINATION("memory limit exceeded",UNKNOWN);
    }
    _remainingPieces = CHUNK_SIZE;
  }
  void* result = _free;
  _free += words;
  _remainingPieces -= words;
  return result;
} 
