/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include <iostream>
#include "RuntimeError.hpp"
#include "Error.hpp"
#include "DestructionMode.hpp"
using namespace std;
using namespace BK;
void (*RuntimeError::reportFun)(const char* msg) = RuntimeError::defaultReport;
void (*RuntimeError::errorHook)() = 0;
void RuntimeError::defaultReport(const char* msg)
{
  RUNTIME_ERR_OUT_STR << "Runtime error: " << msg << "\n";
  DestructionMode::makeFast();
  throw Error(msg);
};
#ifdef NO_DEBUG
BK::Error::Error(const char* msg)
  : _message(msg)
{
}
#else
BK::Error::Error(const char* msg)
  : _message(msg)
{
  cout << msg << "\n";
  Debug::history(cout);
}
#endif
