/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef JARGON_H
#define JARGON_H
#include <new>
#include <iostream>
using namespace std;
#define BK_COMPILER_GCC_2_95_GENERIC 0
#define BK_COMPILER_GCC_3_GENERIC 1
#define BK_COMPILER_MSVCPP_GENERIC 2
#define BK_COMPILER_FAMILY_GCC_2_95 0
#define BK_COMPILER_FAMILY_GCC_3 1
#define BK_COMPILER_FAMILY_MSVCPP 2
#define BK_TARGET_OPERATIONAL_ENVIRONMENT_UNIX_GENERIC 0
#define BK_TARGET_OPERATIONAL_ENVIRONMENT_MSWIN32_GENERIC 1
#define BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE_UNIX 0
#define BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE_MSWIN32 1
#undef BK_COMPILER
#undef BK_COMPILER_FAMILY 
#if defined __GNUG__
#    define BK_COMPILER BK_COMPILER_GCC_3_GENERIC
#    define BK_COMPILER_FAMILY BK_COMPILER_FAMILY_GCC_3
#elif (defined _MSC_VER) 
#  if (_MSC_VER >= 1200)
#    define BK_COMPILER BK_COMPILER_MSVCPP_GENERIC
#    define BK_COMPILER_FAMILY BK_COMPILER_FAMILY_MSVCPP
#  else
#    error "Currently unsupported version of Microsoft C/C++ compiler. Contact the BlodKorv library maintainers."
#  endif
#else
#  error "Currently unsupported compiler family. Contact the BlodKorv library maintainers."
#endif
#undef BK_TARGET_OPERATIONAL_ENVIRONMENT
#undef BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE
#if ((defined unix) || (defined __unix__) || (defined linux) || (defined __linux__))
#  define BK_TARGET_OPERATIONAL_ENVIRONMENT BK_TARGET_OPERATIONAL_ENVIRONMENT_UNIX_GENERIC
#  define BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE_UNIX
#elif (defined _WIN32)
#  define BK_TARGET_OPERATIONAL_ENVIRONMENT BK_TARGET_OPERATIONAL_ENVIRONMENT_MSWIN32_GENERIC
#  define BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE BK_TARGET_OPERATIONAL_ENVIRONMENT_TYPE_MSWIN32
#else
#  error "Currently unsupported target operational environment. Contact the BlodKorv library maintainers."
#endif
typedef unsigned long ulong;
namespace BK 
{
  enum BoolPlus
  {
    DefinitelyFalse = 0UL,
    DefinitelyTrue = 1UL,
    DontKnow = 2UL
  };
  inline BoolPlus boolPlus(bool fl) {
    return (fl)? DefinitelyTrue : DefinitelyFalse;
  };
  template <class C>
  inline
  static 
  void init(C& rawMemory)
  {
    ::new (static_cast<void*>(&rawMemory)) C();
  };
  template <class C,class A1>
  inline
  static 
  void init(C& rawMemory,const A1& arg1)
  {
    ::new (static_cast<void*>(&rawMemory)) C(arg1);
  };
  template <class C,class A1,class A2>
  inline
  static 
  void init(C& rawMemory,const A1& arg1,const A2& arg2)
  {
    ::new (static_cast<void*>(&rawMemory)) C(arg1,arg2);
  };
  template <class C,class A1,class A2,class A3>
  inline
  static 
  void init(C& rawMemory,const A1& arg1,const A2& arg2,const A3& arg3)
  {
    ::new (static_cast<void*>(&rawMemory)) C(arg1,arg2,arg3);
  };
  template <class C>
  inline
  static 
  void destroy(C& obj)
  {
    obj.~C();
  };
  template <class C>
  class DefaultRelocation
  {
  public:
    static void move(C& source,void* target)
    {
      ::new (target) C(source);
      source.~C();
    };
  };
  template <class C>
  class FastRelocation
  {
  public:
    static void move(C& source,void* target)
    {
      ::new (target) C(source);
    };
  };
  template <class C>
  class CustomRelocation
  {
  public:
    static void move(C& source,void* target)
    {
      source.relocateTo(target);
    };
  };
  template <class C>
  inline
  static
  void hibernate(C& obj)
  {
  };
  extern std::ostream nullStream;
}; 
#endif
