/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Calculator__
#define __Calculator__
#include "Assertion.hpp"
namespace Shell {
class Calculator {
public:
  explicit Calculator(int infinity)
    : _inf(infinity)
  {
    ASS(infinity > 0);
  }
  int plus(int i1,int i2)
  {
    int result = i1 + i2;
    return result < _inf ? result : _inf;
  } 
  int mult(int i1,int i2)
  {
    int result = i1 * i2;
    return result < _inf ? result : _inf;
  } 
  bool infinite(int i)
  {
    return i >= _inf;
  }
private:
  const int _inf;
}; 
} 
#endif
