/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "Bag.hpp"
#include "CommandLine.hpp"
#include "Environment.hpp"
#include "Options.hpp"
#include "Tracer.hpp"
#include "VampireException.hpp"
using namespace Shell;
CommandLine::CommandLine (int argc, char* argv [])
  : _next(argv+1),
    _last(argv+argc)
{
  TRACER ("CommandLine::CommandLine");
} 
void CommandLine::interpret ()
{
  TRACER ("CommandLine::interpret");
  while (_next != _last) {
    ASS(_next < _last);
    const char* arg = *_next++;
    if (arg[0] == '-') {
      if (_next == _last) {
	USER_ERROR((string)"no value specified for option " + arg);
      }
      if (arg[1] == '-') {
	if (strcmp(arg+2,"bag") == 0) {
	  Bag::interpret(*_next);
	}
	else if (! Environment::set(arg+2,*_next)) {
	  Environment::options(0)->set(arg+2,*_next);
	}
      }
      else {
	Environment::options(0)->setShort(arg+1,*_next);
      }
      _next++;
    }
    else { 
      string fileName(arg);
      bool active = true;
      Environment::loadKB("$",fileName,&active,0);
      Environment::options(0)->setInputFile(arg);
    }
  }
} 
