/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Definition__
#define __Definition__
#include "Var.hpp"
namespace Shell {
class Term;
class TermList;
class Atom;
class Clause;
class Formula;
class Unit;
class Problem;
class FunctionSymbol;
class PredicateSymbol;
class Definition
{
public:
  static bool makeDefinition (const Unit& original, Unit& def); 
  static int removeUnusedPredicateDefinitions (Problem&);
private:
  static bool isPredicateDefinition (const Formula&, Atom& lhs, Formula& rhs);
  static bool isPredicateDefinition (const Atom& lhs, const Formula& rhs);
  static bool occurs (const PredicateSymbol&, const Formula&);
  static int findPredicateDefinitions (Problem&);
}; 
}
#endif
