/**
 * @file Hash.cpp
 * Implements the class Hash for various hash functions.
 * @since 31/03/2006 Redmond
 */

#include "Assertion.hpp"
#include "Tracer.hpp"

#include "Hash.hpp"

using namespace std;
using namespace Shell;

/**
 * The FNV-hashing.
 * @since 31/03/2006
 */
unsigned Hash::hashFNV (const unsigned char* val,size_t size)
{
  TRACER("Hash::hashFNV/1");
  ASS(size > 0);

  unsigned hash = 2166136261u;
  for (int i = size-1;i >= 0;i--) {
    hash = (hash ^ val[i]) * 16777619u;
  }
  return hash;
} // Hash::hashFNV(const char* str)

/**
 * The FNV-hashing.
 * @since 31/03/2006
 */
unsigned Hash::hash (const char* val)
{
  TRACER("Hash::hashFNV/2");

  unsigned hash = 2166136261u;
  while (*val) {
    hash = (hash ^ *val) * 16777619u;
    val++;
  }
  return hash;
} // Hash::hash(const char* val)

