/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Inference__
#define __Inference__
#include "Unit.hpp"
namespace Shell {
class InferenceInfo;
class Inference
{
public:
  Inference (InferenceRule r);
  Inference (InferenceRule r, const Unit& premise);
  Inference (InferenceRule r, const UnitList& premises);
  Inference (const UnitList& premises,
	     VampireKernel::Clause::BackgroundFlagIterator& flags);
  Inference (InferenceRule r, const Unit& premise, InferenceInfo* info);
  ~Inference ();
  const UnitList& premises () const { return _premises; }
  InferenceRule rule () const { return _rule; }
  InferenceInfo* info () const { return _info; }
  void setInfo (InferenceInfo* info){ _info = info; }
  CLASS_NAME("Inference");
  USE_ALLOCATOR(Inference);
  XML::Element* toXML () const;
  static string toString (InferenceRule);
  string toString() const;
protected:
  InferenceRule _rule;
  UnitList _premises;
  InferenceInfo* _info;
}; 
}
#endif 
