/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include <cstdio>
#include <iostream>
#include <cerrno>
#include "Int.hpp"
#include "Tracer.hpp"
using namespace Shell;
string Int::toString (int i)
{
  char tmp [20];
  sprintf(tmp,"%d",i);
  string result(tmp);
  return result;
} 
string Int::toString(double d)
{
  char tmp [256];
  sprintf(tmp,"%g",d);
  string result(tmp);
  return result;
} 
string Int::toString(long l)
{
  char tmp [256];
  sprintf(tmp,"%ld",l);
  string result(tmp);
  return result;
} 
string Int::toString(unsigned long l)
{
  char tmp [256];
  sprintf(tmp,"%ld",l);
  string result(tmp);
  return result;
} 
bool Int::stringToLong (const char* str,long& result)
{
  TRACER("Int::stringToLong");
  errno = 0;
  char* endptr = 0;
  result = strtol(str,&endptr,10);
  if (*endptr || 
      (result == 0 && errno)) { 
    return false;
  }
  return true;
} 
bool Int::stringToInt (string& str,int& result)
{
  TRACER("Int::stringToInt");
  return stringToInt(str.c_str(),result);
} 
bool Int::stringToUnsignedInt (const char* str,int& result)
{
  TRACER("Int::stringToUnsignedInt");
  return stringToInt(str,result) && 
         result >= 0;
} 
bool Int::stringToInt (const char* str,int& result)
{
  long ln;
  bool converted = stringToLong(str,ln);
  if (! converted || ln > INT_MAX || ln < INT_MIN) {
    return false;
  }
  result = (int)ln;
  return true;
} 
bool Int::stringToDouble (const char* str,double& result)
{
  TRACER("Int::stringToDouble");
  errno = 0;
  char* endptr = 0;
  result = strtod(str,&endptr);
  if (*endptr || 
      (result == 0.0 && errno)) { 
    return false;
  }
  return true;
} 
bool Int::stringToFloat (const char* str,float& result)
{
  double d;
  bool converted = stringToDouble(str,d);
  if (! converted) {
    return false;
  }
  result = (float)d;
  return true;
} 
