/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __INT__
#define __INT__
#include <climits>
#include <string>
using namespace std;
#ifdef _MSC_VER 
#  undef max
#  undef min
#endif
namespace Shell {
class Int 
{
 public:
  static const int greatestNumber();
  static const int leastNumber();
  static string toString(int i);
  static string toString(long l);
  static string toString(unsigned long l);
  static string toString(float f) { return toString((double)f); }
  static string toString(double d);
  static int compare(int i1,int i2);
  static int compare(long l1,long l2);
  static int compare(float i1,float i2);
  static int compare(double i1,double i2);
  static bool stringToLong(const char*,long& result);
  static bool stringToUnsignedLong(const char*,unsigned long& result);
  static bool stringToLong(string& str,long& result);
  static bool stringToInt(string& str,int& result);
  static bool stringToInt(const char* str,int& result);
  static bool stringToUnsignedInt(const char* str,int& result);
  static bool stringToDouble(const char*,double& result);
  static bool stringToFloat(const char*,float& result);
  static int sign(int i);
  static int sign(long i);
  static int sign(double);
  static int max(int i,int j);
  static int min(int i,int j);
};
inline
const int Int::greatestNumber ()
{
  return INT_MAX;
}
inline
const int Int::leastNumber ()
{
  return INT_MIN;
}
inline
int Int::compare (int i1, int i2)
{
  return i1 < i2 ? -1 :
         i1 == i2 ? 0 :
         1;
}
inline
int Int::compare (long l1, long l2)
{
  return l1 < l2 ? -1 :
         l1 == l2 ? 0 :
         1;
}
inline
int Int::compare (double i1, double i2)
{
  return i1 < i2 ? -1 :
         i1 == i2 ? 0 :
         1;
}
inline
int Int::sign(int i)
{
  return i < 0 ? -1 :
         i == 0 ? 0 :
         1;
}
inline
int Int::sign(long l)
{
  return l < 0 ? -1 :
         l == 0 ? 0 :
         1;
}
inline
int Int::sign(double d)
{
  return d < 0 ? -1 :
         d == 0 ? 0 :
         1;
}
inline
int Int::max (int i,int j)
{
  return i >= j ? i : j;
}
inline
int Int::min (int i,int j)
{
  return i <= j ? i : j;
}
}
#endif  
