/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __IntNameTable__
#define __IntNameTable__
#include <string>
#include "List.hpp"
#include "Pair.hpp"
using namespace std;
namespace Shell {
typedef Pair <int,string> Entry;
typedef List <Entry*> EntryList;
class IntNameTable 
{
 public:
  IntNameTable ();
  ~IntNameTable ();
  int insert (const string& str);
  string operator[] ( int num ) const;
  int numberOfSymbols ();
  static IntNameTable vars;
 private:
  static const int _noOfBuckets;
  EntryList ** _buckets;
  int _nextNumber;
  static int hash (string);  
}; 
}
#endif
