/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Lists__
#define __Lists__
#include <string>
#include "Lst.hpp"
namespace Shell {
using namespace std;
class IntList 
  : public Lst<int>
{
 public:
  IntList ();
  IntList (const IntList&);
  explicit IntList (int); 
  IntList (int head, const IntList& tail);
  const IntList& tail () const
    { return static_cast<const IntList&>(Lst<int>::tail()); }
  string toString () const;
}; 
inline
IntList::IntList () 
  : 
  Lst<int> ()
{
} 
inline
IntList::IntList (const IntList& ts)
  :
  Lst<int> (ts)
{
} 
inline
IntList::IntList (int hd, const IntList& tl)
  :
  Lst<int> (hd,tl)
{
} 
inline
IntList::IntList (int hd)
  :
  Lst<int> (hd)
{
} 
}
#endif 
