/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __LiteralOrderingFinder__
#define __LiteralOrderingFinder__
#include "Unit.hpp"
namespace Shell {
class Problem;
class Options;
class Signature;
class LiteralOrderingFinder {
public:
  LiteralOrderingFinder (const Problem&, const Options&, Signature&);
  ~LiteralOrderingFinder ();
  void findOrdering ();
private:
  class Counter;
  class ArityComparator;
  void registerOccurrences();
  void registerOccurrences (const Unit&);
  void registerOccurrences (const Formula&, InputType, int polarity);
  void registerOccurrences (const Clause&, InputType);
  void registerOccurrences (const Atom&, InputType, int polarity);
  void registerOccurrences (const Term&, InputType, int polarity);
  void registerOccurrence (Symbol&, InputType, int polarity);
  const Problem& _problem;
  const Options& _options;
  Signature& _signature;
  int _lastSymbol;
  Counter* _functions;
  Counter* _predicates;
};
}
#endif
