/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __NNF__
#define __NNF__
namespace Shell {
class Formula;
class FormulaList;
class InferenceInfo;
class Position;
class Unit;
class NNF
{
public:
  static void ennf (Unit& f);
  static void nnf (Unit& f);
private:
  static void ennf (Formula&, bool polarity, 
		    InferenceInfo*&, const Position&);
  static void ennf (FormulaList&, bool polarity, int n,
		    InferenceInfo*&, const Position&);
  static void nnf (Formula&, bool polarity,
		   InferenceInfo*&, const Position&);
  static void nnf (FormulaList&, bool polarity, int n,
		   InferenceInfo*&, const Position&);
}; 
}
#endif
