/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __pair__
#  define __pair__
#include "Allocator.hpp"
namespace Shell {
template <class C, class D>
class Pair
{
 public:
  inline
  Pair ( C left, D right )
    :
    _left ( left ),
    _right ( right ) {}
  inline
  Pair () {}
  inline C left () const { return _left; }
  inline D right () const { return _right; }
  inline void left ( C lft ) { _left = lft; }
  inline void right ( D rht ) { _right = rht; }
  inline 
  bool operator == ( Pair& rhs ) const 
    { return left() == rhs.left() &&
             right() == rhs.right(); }
  CLASS_NAME("Pair");
  USE_ALLOCATOR(Pair);
 protected:  
  C _left;
  D _right;
};  
}
#endif
