/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Parser__
#define __Parser__
#include "Token.hpp"
#include "VampireException.hpp"
#include "XML.hpp"
using namespace std;
#define TOKEN_BUFFER_SIZE 3
namespace Shell {
class Atom;
class Clause;
class Formula;
class Lexer;
class Literal;
class LiteralList;
class Parser;
class Term;
class TermList;
class Token;
class Unit;
class UnitList;
class VarList;
class ParserException 
  : public VampireException
{
 public:                                
  ParserException (string message,const Token&);
  void cry (ostream&);
  XML::Element* toXML () const;
  ~ParserException () {}
 protected:
  string _message;
}; 
class Parser 
{
public:
  Parser (Lexer& lexer);
  void units (UnitList&);
protected:
  Lexer& _lexer;
  Token _tokens[TOKEN_BUFFER_SIZE];
  int _tokenCursor;
  int _noOfTokens;
  void consumeToken ();
  void consumeToken (TokenType);
  void readToken ();
  Token& lookAhead (int lookahead);
  Token& currentToken () { return lookAhead(0); }
  static int var (const Token& t);
  static double real (const Token& t);
  static int integer (const Token& t);
}; 
}
#endif
