/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Preprocess__
#define __Preprocess__
namespace Shell {
class Unit;
class Options;
class Problem;
class Property;
class Preprocess
{
public:
  Preprocess(Problem& problem, 
	     const Options& options,
	     const Property& property);
  void preprocess();
private:
  void preprocess1(Unit&);
  void preprocess2(Unit&);
  void preprocess3(Unit&);
  void normalise();
  int removeEqualityAxioms();
  Problem& _problem;
  const Options& _options;
  const Property& _property;
}; 
}
#endif
