/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */
#ifndef __Problem__
#define __Problem__
#include <cstring>
#include "Unit.hpp"
#include "XML.hpp"
namespace Shell {
class FSymbol;
class Options;
class Problem 
{
 public:
  Problem (const string& name, const UnitList&);
  ~Problem ();
  const UnitChain& units () const { return _units; }
  UnitChain& giveUnits () { return _units; }
  bool hasFormulas () const { return _hasFormulas; }
  string name () const {return _name;};
  int split ();
  void addUnit(Unit u); 
  void removeAllConjectures (); 
  XML::Element* toXML () const;
  string toString() const;
 private:
  void* operator new (size_t);
  UnitChain _units;
  bool _hasFormulas;
  string _name;
};
}
#endif 
