/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Statistics__
#define __Statistics__
#include <string>
#include "Options.hpp"
#include "VampireKernel/VampireKernel.hpp"
#include "XML.hpp"
using namespace std;
namespace Shell {
class Kernel;
class Statistics {
 public:
  Statistics(const Kernel&);
  string toString() const;
  XML::Element* toXML () const;
  void setResult(const string& result) { _result = result; }
  void output(ostream& str, const Options& opts) const;
  void* operator new(size_t);
 private:
  const VampireKernel& _kernel;
  const VampireKernel::Statistics& _statistics;
  string _result;
  Options::Statistics _level;
  long memoryInBytes() const;
  static string toString(VampireKernel::TerminationReason);
  friend class SpiderMode;
}; 
};
#endif 
