/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Syntax__
#define __Syntax__
#include <string>
#include <iostream>
using namespace std;
namespace Shell {
class UnitList;
class Formula;
enum InputSyntax {
  IS_KIF = 0,
  IS_TPTP = 1
};
enum OutputSyntax {
  OS_KIF = 0,
  OS_TPTP = 1,
  OS_VAMPIRE = 2
};
class Syntax {
public:
  static InputSyntax stringToInputSyntax(const string&);
  static OutputSyntax stringToOutputSyntax(const string&);
  static void readUnits(const string& text,UnitList&,InputSyntax);
  static void readUnits(istream&,UnitList&,InputSyntax);
  static void readFormula(const string& text,Formula&,InputSyntax);
private:
  class Constants;
};
}
#endif
