/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __TPTP__
#define __TPTP__
#include "Var.hpp"
#include "Connective.hpp"
#include <string>
namespace Shell {
class Symbol;
class Atom;
class Literal;
class Clause;
class Formula;
class Unit;
class Refutation;
class Problem;
class TPTP
{
public:
  static string toString (const Problem&);
  static string toString (const Refutation&);
  static string toString (const Literal&);
private:
  static string toString (const Symbol&);
  static string toString (const Atom&);
  static string toString (const Clause&);
  static string toString (const Formula&);
  static string toString (const Formula&, Connective);
  static string toString (const Unit&);
  static string toStringAsInference (const Unit&);
}; 
}
#endif 
