/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __TPTPParser__
#define __TPTPParser__
#include "Parser.hpp"
#include "VampireException.hpp"
using namespace std;
namespace Shell {
class Atom;
class Clause;
class Formula;
class TPTPLexer;
class Literal;
class LiteralList;
class TPTPParser;
class Term;
class TermList;
class Unit;
class UnitList;
class VarList;
class TPTPParser
  : public Parser 
{
public:
  TPTPParser(TPTPLexer& lexer);
  void units(UnitList&);
  void formula(Formula&);
private:
  class UnitStack;
  void units(UnitStack&);
  void unit(UnitStack&);
  void clause(Clause&);
  void formulaClause(Clause&);
  void xorFormula(Formula&);
  void impFormula(Formula&);
  void orFormula(Formula&);
  void andFormula(Formula&);
  void simpleFormula(Formula&);
  void varList(VarList&);
  void atom(Atom&,bool& positive);
  void args(TermList& ts);
  void terms(TermList& ts);
  void term(Term&);
  void termList(TermList&);
  string name();
  void literal(Literal&);
  void formulaLiteral(Literal&);
  void literals(LiteralList&);
  void formulaLiterals(LiteralList&);
  void include(UnitStack&);
}; 
}
#endif
