/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __Tautology__
#define __Tautology__
namespace Shell {
class Term;
class TermList;
class Atom;
class Literal;
class LiteralList;
class Unit;
class Tautology {
public:
  static int isTautology (const Unit& in, Unit& out);
  bool lessThan (const Literal& lit1,const Literal& lit2);
private:
  static int isTautology (const LiteralList& in, LiteralList& out);
  static int compare (const Atom& a1,const Atom& a2);
  static int compare (const Term& t1,const Term& t2);
  static int compare (const TermList& ts1,const TermList& ts2);
}; 
}
#endif
