/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef __TermFunIterator__
#define __TermFunIterator__
namespace Shell {
class Term;
class TermList;
class Atom;
class Literal;
class FunctionSymbol;
class TermFunIterator
{
public:
  TermFunIterator (const Term&);
  TermFunIterator (const TermList&);
  TermFunIterator (const Atom&);
  TermFunIterator (const Literal&);
  ~TermFunIterator ();
  bool hasNext ();
  const FunctionSymbol& next ();
private:
  class Element {
  public:
    Element (const TermList& list, Element* rest) 
      : _list(const_cast<TermList*>(&list)), _rest(rest) {}
    TermList* _list;
    Element* _rest;
  };
  Term* _current;
  Element* _reserve;
}; 
}
#endif 
