/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "Token.hpp"
#include "Tracer.hpp"
#include "VampireException.hpp"
using namespace Shell;
string Token::toString (TokenType tt)
{
  switch (tt) {
  case TT_INTEGER:
    return "<integer>";
  case TT_REAL:
    return "<real>";
  case TT_ROW_VARIABLE:
    return "<row variable>";
  case TT_STRING:
    return "<string>";
  case TT_EOF:
    return "<end-of-file>";
  case TT_LPAR:
    return "(";
  case TT_RPAR:
    return ")";
  case TT_LBRA:
    return "[";
  case TT_RBRA:
    return "]";
  case TT_COMMA:
    return ",";
  case TT_COLON:
    return ":";
  case TT_DOT  :
    return ".";
  case TT_AND:
    return "&";
  case TT_NOT:
    return "~";
  case TT_OR:
    return "|";
  case TT_IFF:
    return "<=>";
  case TT_IMP:
    return "=>";
  case TT_XOR:
    return "<~>";
  case TT_FORALL:
    return "!";
  case TT_EXISTS:
    return "?";
  case TT_PP:
    return "++";
  case TT_MM:
    return "--";
  case TT_EQUAL:
    return "=";
  case TT_NAME:
    return "<name>";
  case TT_VAR:
    return "<variable>";
  case TT_INPUT_FORMULA: 
    return "input_formula";
  case TT_INPUT_CLAUSE:
    return "input_clause";
  case TT_INCLUDE:
    return "include";
  case TT_GREATER_THAN:
    return ">";
  case TT_LESS_THAN:
    return "<";
  case TT_END_OF_EMPTY_TAG:
    return "/>";
  case TT_TEXT:
    return "<text>";
  case TT_CLOSING_TAG:
    return "</";
#if DEBUG_SHELL
  default:
    ASSERTION_VIOLATION;
#endif
  }
} 
