/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef CLAUSE_NUM_INDEX_HPP
#define CLAUSE_NUM_INDEX_HPP
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"    
#include "SkipList.hpp"
#include "GlobAlloc.hpp"
#include "DestructionMode.hpp"
namespace VK
{
  class Clause;
}; 
#undef DEBUG_NAMESPACE
#ifdef DEBUG_CLAUSE_NUM_INDEX
#  define DEBUG_NAMESPACE "ClauseNumIndex"
#endif
#include "debugMacros.hpp"
namespace VK
{
  class ClauseNumIndex
  {  
  public:
    typedef BK::SkipList<BK::GlobAlloc,Clause*,ulong> List;
  public:
    ClauseNumIndex() 
    {
      CALL("constructor ClauseNumIndex()");
      unlock();
    };
    ~ClauseNumIndex() 
    { 
      CALL("destructor ~ClauseNumIndex()");  
    };
    void reset()
    {
      _list.reset();
      unlock();
    };
    bool isLocked() const { return _isLocked; };
    void insert(Clause* cl);
    void remove(Clause* cl);
    Clause* find(ulong num);
  private:
    void lock() { _isLocked = true; };
    void unlock() { _isLocked = false; };
  private:
    List _list;
    List::Surfer _surfer;
    bool _isLocked;
  }; 
}; 
#endif
