/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef FORWARD_SUBSUMPTION_FRONT_END_HPP
#define FORWARD_SUBSUMPTION_FRONT_END_HPP 
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "ForwardSubsumption.hpp"
#include "TemporaryLiteral.hpp"
#include "BasicTempLitList.hpp"
#include "ClauseBackground.hpp"
#include "LiteralList.hpp"
#undef DEBUG_NAMESPACE
#ifdef DEBUG_FORWARD_SUBSUMPTION_FRONT_END
#define DEBUG_NAMESPACE "ForwardSubsumptionFrontEnd"
#endif
#include "debugMacros.hpp"
namespace VK
{
class ForwardSubsumptionFrontEnd : public ForwardSubsumption
{
 public: 
  ForwardSubsumptionFrontEnd();
  ~ForwardSubsumptionFrontEnd();
  void reset();
  bool isLocked() const { return _isLocked; };
  void setSubsumptionResolutionMinLength(ulong ln) 
    {
      _subsumptionResolutionMinLength = ln;
    };
  void integrate(Clause* cl);
  void remove(Clause* cl);
  Clause* subsume(BasicTempLitList& lits); 
  ulong simplifyBySubsumptionResolution(BasicTempLitList& lits,OpenClauseBackground& ancestors);
 private: 
  void lock() { _isLocked = true; };
  void unlock() { _isLocked = false; };
  bool pushLiteral(const TemporaryLiteral::Extras::Handle& lit);
 private:
  ulong _subsumptionResolutionMinLength;
  bool _isLocked;
}; 
}; 
#endif
