/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#ifndef STANDARD_LITERAL_ORDERING_HPP
#define STANDARD_LITERAL_ORDERING_HPP
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "Comparison.hpp"
#include "SimplificationOrdering.hpp"
#include "TemporaryLiteral.hpp"
#include "Signature.hpp"
#include "LiteralOrdering.hpp"
#undef DEBUG_NAMESPACE
#ifdef DEBUG_STANDARD_LITERAL_ORDERING
#  define DEBUG_NAMESPACE "StandardLiteralOrdering"
#endif
#include "debugMacros.hpp"
namespace VK
{
  class StandardLiteralOrdering : public LiteralOrdering
  {
  public:
    StandardLiteralOrdering();    
    ~StandardLiteralOrdering();
    BK::Comparison compare(TemporaryLiteral& lit1,
			   TemporaryLiteral& lit2) const;
    BK::Comparison compareLayers(const TemporaryLiteral& lit1,
				 const TemporaryLiteral& lit2) const;
  private:
    BK::Comparison compareEqSamePolarity(TemporaryLiteral& lit1,
					 TemporaryLiteral& lit2) const;
    BK::Comparison compareEqAtomsOO(TemporaryLiteral& lit1,
				TemporaryLiteral& lit2) const;
    BK::Comparison compareEqAtomsOU(TemporaryLiteral& lit1,
				TemporaryLiteral& lit2) const;
    BK::Comparison compareEqAtomsUU(TemporaryLiteral& lit1,
				TemporaryLiteral& lit2) const;
    BK::Comparison compareEqNegPos(TemporaryLiteral& lit1,
				   TemporaryLiteral& lit2) const;
    BK::Comparison compareEqNegPosOO(TemporaryLiteral& lit1,
				     TemporaryLiteral& lit2) const;
    BK::Comparison compareEqNegPosOU(TemporaryLiteral& lit1,
				     TemporaryLiteral& lit2) const;
    BK::Comparison compareEqNegPosUO(TemporaryLiteral& lit1,
				     TemporaryLiteral& lit2) const;
    BK::Comparison compareEqNegPosUU(TemporaryLiteral& lit1,
				     TemporaryLiteral& lit2) const;
  }; 
}; 
#endif
