/**
 * Copyright (c) 2007 Andrei Voronkov and the University of Manchester.
 *
 * This version of Vampire is intended to be used only for CASC-21.
 * It is not a full version of Vampire.
 *
 * The only reason you can view the source code of this software is
 * that it is required by the conditions of CASC. You are not allowed
 * to use, modify or distribute this software or any part of it in any form.
 * To obtain a licence to use this software please check Vampire's
 * Web page. If you are interested in Vampire's implementation you
 * can check publications on Vampire.
 */

#include "BlodKorvDebugFlags.hpp"
#ifdef NO_DEBUG
 #undef NO_DEBUG_VIS
 #define NO_DEBUG_VIS
#endif 
#define DEBUG_LPO
#ifdef NO_DEBUG
 #undef DEBUG_AUTO_FUNCTOR_PRECEDENCE
 #undef DEBUG_BACK_DEMODULATION
 #undef DEBUG_BACK_PARA_CANDIDATES
 #undef DEBUG_BACKWARD_FOLDING
 #undef DEBUG_BACKWARD_SUBSUMPTION
 #undef DEBUG_BACKWARD_SUPERPOSITION
 #undef DEBUG_BASIC_TEMP_LIT_LIST
 #undef DEBUG_BINARY_RESOLUTION
 #undef DEBUG_BS_INDEX
 #undef DEBUG_BS_INDEX_FRONT_END
 #undef DEBUG_BS_MACHINE
 #undef DEBUG_BS_SUBSTITUTION_CACHE
 #undef DEBUG_BUILT_IN_FLOATING_POINT_ARITHMETIC
 #undef DEBUG_BUILT_IN_INTERPRETATION
 #undef DEBUG_BUILT_IN_THEORY
 #undef DEBUG_BUILT_IN_THEORY_DISPATCHER
 #undef DEBUG_CHAINING
 #undef DEBUG_CLAUSE
 #undef DEBUG_CLAUSE_ASSEMBLER
 #undef DEBUG_CLAUSE_BACKGROUND
 #undef DEBUG_CLAUSE_NUM_INDEX
 #undef DEBUG_CLAUSE_SET 
 #undef DEBUG_COMPONENT_NAME
 #undef DEBUG_CUSTOM_LITERAL_SELECTION
 #undef DEBUG_DEFINED_HEADER_TABLE
 #undef DEBUG_DIV_INTO_COMP
 #undef DEBUG_DISC_TREE
 #undef DEBUG_EQUALITY_FACTORING
 #undef DEBUG_FLATTERM
 #undef DEBUG_FORWARD_MATCHING_INDEX
 #undef DEBUG_FORWARD_MATCHING_INDEX_TREE
 #undef DEBUG_FORWARD_PROCESSING
 #undef DEBUG_FORWARD_SUBSUMPTION
 #undef DEBUG_FORWARD_SUBSUMPTION_FRONT_END
 #undef DEBUG_FORWARD_SUPERPOSITION
 #undef DEBUG_FORWARD_DEMODULATION
 #undef DEBUG_FORWARD_MATCHING_SUBSTITUTION_CACHE
 #undef DEBUG_FORWARD_SUBSUMPTION_CODE
 #undef DEBUG_FORWARD_SUBSUMPTION_COMMAND
 #undef DEBUG_FT_UNIFICATION
 #undef DEBUG_INFERENCE_DISPATCHER
 #undef DEBUG_INFERENCE_TREE
 #undef DEBUG_INPUT
 #undef DEBUG_INSTANCE_RETRIEVAL_FOR_DEMODULATION
 #undef DEBUG_INSTANCE_WITH_UNIFIER
 #undef DEBUG_IU_COMMAND
 #undef DEBUG_IU_TRANSLATOR
 #undef DEBUG_IU_MACHINE
 #undef DEBUG_KB_COMMAND
 #undef DEBUG_KB_CONSTRAINT
 #undef DEBUG_LARGE_WEIGHT_POLYNOMIAL
 #undef DEBUG_LITERAL_LIST
 #undef DEBUG_LITERAL_ORDERING
 #undef DEBUG_LITERAL_PROPERTIES
 #undef DEBUG_LITERAL_SELECTION
 #undef DEBUG_LITERAL_SHARING
 #undef DEBUG_LOCAL_UNIFICATION
 #undef DEBUG_LPO
 #undef DEBUG_MASTER
 #undef DEBUG_NEGATIVE_EQUALITY_SPLITTING
 #undef DEBUG_NONRECURSIVE_KB_ORDERING
 #undef DEBUG_NONUNIFORM_ARGUMENT_SENSITIVE_TERM_WEIGHTING
 #undef DEBUG_NONUNIFORM_CONSTANT_TERM_WEIGHTING
 #undef DEBUG_OLD_BACKWARD_SUBSUMPTION
 #undef DEBUG_OLD_BS_INDEX
 #undef DEBUG_OLD_BS_MACHINE
 #undef DEBUG_ORDINARY_UNIFICATION
 #undef DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
 #undef DEBUG_PARSER
 #undef DEBUG_PASSIVE_CLAUSE_SET
 #undef DEBUG_PATH_INDEX
 #undef DEBUG_PATH_INDEX_WITH_OPEN_PATHS
 #undef DEBUG_PATH_INDEXING_FOR_INSTANCE_RETRIEVAL
 #undef DEBUG_PREMISE_WITH_FACTORING
 #undef DEBUG_PROBLEM_PROFILE
 #undef DEBUG_PROPOSITIONAL_SPLITTING
 #undef DEBUG_RULE_PREMISE
 #undef DEBUG_SHARED_KB_CONSTR
 #undef DEBUG_SIGMA
 #undef DEBUG_SIGNATURE 
 #undef DEBUG_SIMPLE_SUBSTITUTION
 #undef DEBUG_SIMPLIFICATION_ORDERING
 #undef DEBUG_SIZE_FORMULA
 #undef DEBUG_STANDALONE
 #undef DEBUG_STANDARD_KB_ORDERING
 #undef DEBUG_STANDARD_LITERAL_ORDERING
 #undef DEBUG_STATISTICS
 #undef DEBUG_SUBSUMPTION_CHECK
 #undef DEBUG_SYMBOL
 #undef DEBUG_SYMBOL_INFO
 #undef DEBUG_TABULATION
 #undef DEBUG_TEMPORARY_CLAUSE
 #undef DEBUG_TEMPORARY_CLAUSE_COLLECTOR
 #undef DEBUG_TEMPORARY_CLAUSE_QUEUE
 #undef DEBUG_TEMPORARY_LITERAL
 #undef DEBUG_TEMP_LIT_LIST_EXTRAS
 #undef DEBUG_TERM
 #undef DEBUG_TERM_SHARING
 #undef DEBUG_UI_TREE
 #undef DEBUG_UNIFICATION
 #undef DEBUG_UNIFIER 
 #undef DEBUG_UNIFORM_TERM_WEIGHTING
 #undef DEBUG_UNIF_INDEX
 #undef DEBUG_UNIF_TERM
 #undef DEBUG_UNIT_CONFLICT
 #undef DEBUG_U_TERM
 #undef DEBUG_U_VARIABLE
 #undef DEBUG_VAMPIRE_KERNEL
 #undef DEBUG_VARIABLE_RENAMING
 #undef DEBUG_VARIABLE_WEIGHTING
 #undef DEBUG_VARIABLE_SET
 #undef DEBUG_WEIGHT_POLYNOMIAL
#else
 #ifdef DEBUG_ALL
  #define DEBUG_AUTO_FUNCTOR_PRECEDENCE
  #define DEBUG_BACK_DEMODULATION
  #define DEBUG_BACK_PARA_CANDIDATES
  #define DEBUG_BACKWARD_FOLDING
  #define DEBUG_BACKWARD_SUBSUMPTION
  #define DEBUG_BACKWARD_SUPERPOSITION
  #define DEBUG_BASIC_TEMP_LIT_LIST
  #define DEBUG_BINARY_RESOLUTION
  #define DEBUG_BS_INDEX
  #define DEBUG_BS_INDEX_FRONT_END
  #define DEBUG_BS_MACHINE
  #define DEBUG_BS_SUBSTITUTION_CACHE
  #define DEBUG_BUILT_IN_FLOATING_POINT_ARITHMETIC
  #define DEBUG_BUILT_IN_INTERPRETATION
  #define DEBUG_BUILT_IN_THEORY
  #define DEBUG_BUILT_IN_THEORY_DISPATCHER
  #define DEBUG_CHAINING
  #define DEBUG_CLAUSE
  #define DEBUG_CLAUSE_ASSEMBLER
  #define DEBUG_CLAUSE_BACKGROUND
  #define DEBUG_CLAUSE_NUM_INDEX
  #define DEBUG_CLAUSE_SET
  #define DEBUG_COMPONENT_NAME
  #define DEBUG_CUSTOM_LITERAL_SELECTION
  #define DEBUG_DEFINED_HEADER_TABLE
  #define DEBUG_DIV_INTO_COMP
  #define DEBUG_DISC_TREE
  #define DEBUG_EQUALITY_FACTORING
  #define DEBUG_FLATTERM
  #define DEBUG_FORWARD_MATCHING_INDEX
  #define DEBUG_FORWARD_MATCHING_INDEX_TREE
  #define DEBUG_FORWARD_PROCESSING
  #define DEBUG_FORWARD_SUBSUMPTION
  #define DEBUG_FORWARD_SUBSUMPTION_FRONT_END 
  #define DEBUG_FORWARD_SUPERPOSITION
  #define DEBUG_FORWARD_DEMODULATION
  #define DEBUG_FORWARD_MATCHING_SUBSTITUTION_CACHE
  #define DEBUG_FORWARD_SUBSUMPTION_CODE
  #define DEBUG_FORWARD_SUBSUMPTION_COMMAND
  #define DEBUG_FT_UNIFICATION
  #define DEBUG_INFERENCE_DISPATCHER
  #define DEBUG_INFERENCE_TREE
  #define DEBUG_INPUT
  #define DEBUG_INSTANCE_RETRIEVAL_FOR_DEMODULATION
  #define DEBUG_INSTANCE_WITH_UNIFIER
  #define DEBUG_IU_COMMAND
  #define DEBUG_IU_TRANSLATOR
  #define DEBUG_IU_MACHINE
  #define DEBUG_KB_COMMAND
  #define DEBUG_KB_CONSTRAINT
  #define DEBUG_LARGE_WEIGHT_POLYNOMIAL
  #define DEBUG_LITERAL_LIST
  #define DEBUG_LITERAL_ORDERING
  #define DEBUG_LITERAL_PROPERTIES
  #define DEBUG_LITERAL_SELECTION
  #define DEBUG_LITERAL_SHARING
  #define DEBUG_LOCAL_UNIFICATION
  #define DEBUG_LPO
  #define DEBUG_MASTER
  #define DEBUG_NEGATIVE_EQUALITY_SPLITTING
  #define DEBUG_NONRECURSIVE_KB_ORDERING
  #define DEBUG_NONUNIFORM_ARGUMENT_SENSITIVE_TERM_WEIGHTING
  #define DEBUG_NONUNIFORM_CONSTANT_TERM_WEIGHTING
  #define DEBUG_OLD_BACKWARD_SUBSUMPTION
  #define DEBUG_OLD_BS_INDEX
  #define DEBUG_OLD_BS_MACHINE
  #define DEBUG_ORDINARY_UNIFICATION
  #define DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
  #define DEBUG_PARSER
  #define DEBUG_PASSIVE_CLAUSE_SET
  #define DEBUG_PATH_INDEX
  #define DEBUG_PATH_INDEX_WITH_OPEN_PATHS
  #define DEBUG_PATH_INDEXING_FOR_INSTANCE_RETRIEVAL
  #define DEBUG_PREMISE_WITH_FACTORING
  #define DEBUG_PROBLEM_PROFILE
  #define DEBUG_PROPOSITIONAL_SPLITTING
  #define DEBUG_RULE_PREMISE
  #define DEBUG_SHARED_KB_CONSTR
  #define DEBUG_SIGMA
  #define DEBUG_SIGNATURE
  #define DEBUG_SIMPLE_SUBSTITUTION
  #define DEBUG_SIMPLIFICATION_ORDERING
  #define DEBUG_SIZE_FORMULA
  #define DEBUG_STANDALONE
  #define DEBUG_STANDARD_KB_ORDERING
  #define DEBUG_STANDARD_LITERAL_ORDERING
  #define DEBUG_STATISTICS
  #define DEBUG_SUBSUMPTION_CHECK
  #define DEBUG_SYMBOL
  #define DEBUG_SYMBOL_INFO
  #define DEBUG_TABULATION
  #define DEBUG_TEMPORARY_CLAUSE
  #define DEBUG_TEMPORARY_CLAUSE_COLLECTOR
  #define DEBUG_TEMPORARY_CLAUSE_QUEUE
  #define DEBUG_TEMPORARY_LITERAL
  #define DEBUG_TEMP_LIT_LIST_EXTRAS
  #define DEBUG_TERM
  #define DEBUG_TERM_SHARING
  #define DEBUG_UI_TREE
  #define DEBUG_UNIFICATION 
  #define DEBUG_UNIFIER 
  #define DEBUG_UNIFORM_TERM_WEIGHTING
  #define DEBUG_UNIF_INDEX
  #define DEBUG_UNIF_TERM
  #define DEBUG_UNIT_CONFLICT
  #define DEBUG_U_TERM
  #define DEBUG_U_VARIABLE
  #define DEBUG_VAMPIRE_KERNEL
  #define DEBUG_VARIABLE_RENAMING
  #define DEBUG_VARIABLE_WEIGHTING
  #define DEBUG_VARIABLE_SET
  #define DEBUG_WEIGHT_POLYNOMIAL
 #endif
#endif
