type  elem ='a 
      
module SymKey = 
  struct 
    type t       = symbol
    let  compare = Symbol.compare_key
  end
    
module SymbolDBM =  Map.Make (SymKey)
type   symbolDB  = {db: symbol SymbolDBM.t ; num_of_el: int}


let empty                 =  {db=SymbolDBM.empty; num_of_el=0}
let mem symbol symbol_db  = SymbolDBM.mem symbol symbol_db.db
    
let add (symbol:symbol) (symbol_db:symbolDB)  =  
  if (mem symbol symbol_db) then symbol_db
  else 
    let new_num_of_el = (symbol_db.num_of_el + 1) in
    let ()=(Symbol.assign_fast_key symbol new_num_of_el)
    in	 
    {db        =(SymbolDBM.add symbol symbol symbol_db.db); 
     num_of_el = new_num_of_el }
      
let find symbol symbol_db =  SymbolDBM.find symbol symbol_db.db
    

let num_of_el symbol_db = symbol_db.num_of_el    
    
let remove symbol symbol_db =  
  {db        = (SymbolDBM.remove symbol symbol_db.db); 
   num_of_el = symbol_db.num_of_el-1}
    
let map f symbol_db = 
  {db        = (SymbolDBM.map f symbol_db.db); 
   num_of_el = symbol_db.num_of_el}
   


