open Lib
type clause = Clause.clause

module ClauseKey =
  struct
    type t       = clause
    let  compare = Clause.compare_key
    let  assign_fast_key = Clause.assign_fast_key
 end

module ClauseDBM =  AbstAssignDB.Make (ClauseKey)

type clauseDB  = ClauseDBM.abstDB

let create_name = ClauseDBM.create_name
let create () = create_name "Clause Assign DB"
let mem      = ClauseDBM.mem
let remove   = ClauseDBM.remove
let find     = ClauseDBM.find
let size     = ClauseDBM.size
let map      = ClauseDBM.map
let fold     = ClauseDBM.fold
let iter     = ClauseDBM.iter

let add_ref clause db_ref  = 
  Clause.assign_all_for_clause_db clause;
  ClauseDBM.add_ref clause db_ref

(* should be copyed since add_ref is different....*)
let add elem elem_db =
      let elem_db_ref = ref elem_db in
      let _= add_ref elem elem_db_ref in
      !elem_db_ref


let get_name = ClauseDBM.get_name


let to_string clause_db = 
  ClauseDBM.to_string Clause.to_string ",\n" clause_db

