(*val start_instantiation : unit -> unit*)

type clause = Clause.clause
type lit = Term.literal
type term = Term.term
type pass_queue_cmp = clause -> clause -> int


module type InstParam =
  sig
    val inst_lit_sel_fun : 
	(lit -> bool) -> clause -> term
    val solver_per_active     : int
    val solver_per_clauses    : int
    val inst_pass_queue1_cmp  :  pass_queue_cmp
    val inst_pass_queue2_cmp  :  pass_queue_cmp
    val inst_pass_queue1_mult : int
    val inst_pass_queue2_mult : int
    val dismatching           : bool
    val eager_unprocessed_to_passive : bool
    val ground_splitting_input : bool
    val ground_splitting_full  : bool
    val learning_loop_flag    : bool
    val learning_start        : int
    val learning_factor       : int
  end

module type Instantiation =
  sig
    val start_instantiation : unit -> unit
  end

module Make (InstParam : InstParam) : (Instantiation)
