type clause  = Clause.clause
type literal = Clause.literal



(* restricted subset subsumption very fast but 
   very incomplete :  
   literals in clauses assumed to be ordered by e.g. fast term comparison
   then we check whether given clause extents a clause in the index 
   and then this clause is subsumed
   or this clause is extended by a clause in the index and then the clause 
   in the index is subsumed 
*)

exception Is_subsumed 
exception Subsumes
exception Already_in 
exception No_subsumed

(*
   module type SubsetSubsume = 
   sig
   type index
   
    val create : unit -> index
   
(* we assume that the literals in the clause are in term db*)
   val add_clause  : clause -> index -> index

(* returns list of  all strictly subsumed clauses by the clause 
   raises No_subsumed if no such clauses*)

   val find_subsumed : clause -> index -> clause list 
    
(* removes a subtrie corr. to all subsumed by the cluase clauses 
   after this the cluase is not in the index 
   for efficience can be joint with find_subsumed  
   (remove clauses from  separately)*)
    
   val  remove_subsumed : clause -> index -> index 
  

(*Restricted Subset subsumed*)
(*    val is_rsubset_subsumed : index -> clause -> bool
   	
(* the list of clauses (rsubset)subsumed by the given clause*)
    val subsumed_clauses : index -> clause -> clause list
	

 (*   val remove : clause -> index ref -> unit	 *)
*)
 end
*)
(*
module SubsetSubsume = 
  struct
*)
module Key =
  struct
    type t      = literal
    let compare = Term.compare
  end
    
module SIndexM = Trie_func.Make(Key)
    type index = clause SIndexM.trie
	  
let create () = SIndexM.create ()

(* is_subsumed check also subclauses on subset subs*)
let rec is_subsumed lit_list index =
  if (SIndexM.long_or_in lit_list index) 
  then true
  else
    match lit_list with 
    |l::tl ->  
	if (SIndexM.long_or_in tl index) then true 
	else is_subsumed tl index
    |[] -> false
	  

let is_subsumed clause index = 
  let lit_list = Clause.get_literals clause in
  is_subsumed lit_list index
    


let add_clause clause index = 
  try
    SIndexM.add (Clause.get_literals clause) clause index
  with
  |Trie_func.Trie_add_leaf_extension -> raise Is_subsumed 
  |Trie_func.Trie_add_short_kyelist  -> raise Subsumes
  |Trie_func.Trie_add_already_in     -> raise Already_in 
	
let find_subsumed clause trie = 
  try
    SIndexM.all_elem_short (Clause.get_literals clause) trie
  with 
    Not_found -> raise No_subsumed

let remove_subsumed clause trie = 
  try
    SIndexM.remove_short (Clause.get_literals clause) trie
  with
    Not_found -> raise No_subsumed

(*
   end
 *)

