open Lib

module type Key =
  sig
    type t
    val compare : t -> t -> int
  end

module type Index = 
  sig
    type key
    type keylist = key list
    type 'a index
    val create : unit  -> 'a index
(* copied from trie_func *) 
    val mem    : keylist -> 'a index -> bool
    val add    : keylist -> ('a index) ref-> 'a ref_elem
    val remove : keylist -> ('a index) ref -> unit
(* return element corr. to the keylist and raises Not_found
   if the keylist is not in index *)
    val  find : keylist ->'a index -> 'a ref_elem
(* new for feature indexes*)

(* findf_leq applies f to leaf elements with key list less or equal to key
   (coordinatewise)
   and stops if f returns Some(v) and returns Some(v) otherwise
   reterns None; used in subsumtion index for subsumption *)

    val findf_leq : ('a -> 'b option) -> keylist -> ('a index) ref -> 'b option
    val findf_geq : ('a -> 'b option) -> keylist -> ('a index) ref -> 'b option
	
(* findf_all_leq returns list of all elements with key less or eqaul to key
   and [] if all f return []; f can also change the elements of the index 
   (used to remove subsumed clauses) *)

    val findf_all_geq :  
	(keylist -> 'a ref_elem -> 'b list) -> keylist -> ('a index) ref -> 'b list 
	
(*
    val findf_all_leq :  
	('a ref_elem -> 'b list) -> keylist -> ('a index) ref -> 'b list 
*)
  end

module Make(Key:Key): (Index with type key=Key.t) 
