open Lib

type term = Term.term
    

(*
module  TermKey = 
  struct
    type t = term

(* we assume that symbs are in db *)
    let rec equal (t1:term)(t2:term)  = 
      (t1 == t2) ||
      (match (t1,t2) with 
      |(Term.Fun(symbol1,args1,_),Term.Fun(symbol2,args2,_))->
	  (try
	    (symbol1 == symbol2) && (Term.arg_for_all2 (equal) args1 args2)
	  with 
	    Invalid_argument(_) -> 
	      failwith "TermDB symbs the same but diff args length"
	  )
      | (Term.Var(x,_),Term.Var(y,_)) -> Var.equal x y 
      | _ -> false
      )

  (*  let hash  =  Term.get_hash *)  
    let hash = Term.assign_hash_full
(* val init_num_of_keys : int*)
  end


module TermDBM = Hashtbl.Make (TermKey)

type termDB = (term TermDBM.t)

let name_ref = ref ""
let size_ref = ref 0

let create () = TermDBM.create(1000001)
let create_name name = 
  name_ref:=name; 
  create ()
  


let mem term term_db   = 
  let _= Term.assign_hash_full term in  
  TermDBM.mem term_db term

let remove term term_db = 
  let _= Term.assign_hash_full term in
  (TermDBM.remove term_db term); term_db

let find term term_db  = 
  let _= Term.assign_hash_full term in
  TermDBM.find term_db term

let size term_db  = !size_ref

(*let map    = TermDBM.map*)

let get_name term_db = !name_ref

let fold f term_db a = 
  try 
  TermDBM.fold (fun term_key term a -> (f term a)) term_db a  
  with Term.Term_hash_undef -> failwith "here1"

let iter f term_db  = 
  try 
  (TermDBM.iter (fun term_key term -> (f term)) term_db)  
  with  Term.Term_hash_undef -> failwith "here2"

let to_string term_db = 
  "TermDB to_string Not implemented yet"

(* top down*)

let rec add_ref t db_ref = 
(*  out_str("----------------\n");
  out_str ("Term to DB: "^(Term.to_string t)^"\n");*)
  try 
    find t !db_ref
  with 
    Not_found->
      (match t with
      |Term.Fun(sym, args,info) ->
	  (let new_args = Term.arg_map (fun t' -> add_ref t' db_ref) args in
	  let new_term = Term.create_fun_term_args sym new_args in 
(* add usefull info for terms*)	  
	  Term.assign_fun_all new_term;
	  Term.assign_fast_key new_term !size_ref;
	  size_ref:=!size_ref+1;
	  TermDBM.add !db_ref new_term new_term;
	  new_term)
      |Term.Var(_,_) ->
	  (TermDBM.add !db_ref t t;
	  Term.assign_var_all t;
	  Term.assign_fast_key t !size_ref;
	  size_ref:=!size_ref+1;
	  t)
      )let rec add_ref t db_ref = 
(*  out_str("----------------\n");
  out_str ("Term to DB: "^(Term.to_string t)^"\n");*)
  try 
    find t !db_ref
  with 
    Not_found->
      (match t with
      |Term.Fun(sym, args,info) ->
	  (let new_args = Term.arg_map (fun t' -> add_ref t' db_ref) args in
	  let new_term = Term.create_fun_term_args sym new_args in 
(* add usefull info for terms*)	  
	  Term.assign_fun_all new_term;
	  Term.assign_fast_key new_term !size_ref;
	  size_ref:=!size_ref+1;
	  TermDBM.add !db_ref new_term new_term;
	  new_term)
      |Term.Var(_,_) ->
	  (TermDBM.add !db_ref t t;
	  Term.assign_var_all t;
	  Term.assign_fast_key t !size_ref;
	  size_ref:=!size_ref+1;
	  t)
      )





(* bot up *)

(* 
let rec add_ref t db_ref = 
(*  out_str("----------------\n");
  out_str ("Term to DB: "^(Term.to_string t)^"\n");*)
  (match t with
      |Term.Fun(sym, args,info) ->
	  (let new_args = Term.arg_map (fun t' -> add_ref t' db_ref) args in
	  let new_term = Term.create_fun_term_args sym new_args in 
(* add usefull info for terms*)
(*	  Term.assign_hash new_term;*)
	  try 
	    find t !db_ref
	  with 
	    Not_found->    
	      (Term.assign_fun_all new_term;
	       Term.assign_fast_key new_term !size_ref;
	       size_ref:=!size_ref+1;
	       TermDBM.add !db_ref new_term new_term;
	       new_term)
	  )
      |Term.Var(_,_) ->
	  ( 
	    try 
	      find t !db_ref
	    with 	 
	      Not_found->    
		(TermDBM.add !db_ref t t;
		 Term.assign_var_all t;
		 Term.assign_fast_key t !size_ref;
		 size_ref:=!size_ref+1;
		 t)
	   )
  )

*)

let add t db =
  let db_ref = ref db in
  let _ = add_ref t db_ref in
  !db_ref
 

(*  (try    term in () 
   with Term.Term_hash_undef -> failwith "hash undef here");
*)
(* debug *)
 let get_greatest_key term_db = !size_ref










*)






(***********************Functional**************************)

module TermKey = 
  struct 
    type t       = term
    let  compare = Term.compare_key
    let  assign_fast_key = Term.assign_fast_key
 end
    
module TermDBM =  AbstAssignDB.Make (TermKey)
type termDB  = TermDBM.abstDB

let create_name = TermDBM.create_name
let create () = create_name "Term_DB"
let mem    = TermDBM.mem   
let remove = TermDBM.remove
let find   = TermDBM.find
let size   = TermDBM.size
let map    = TermDBM.map
let get_name = TermDBM.get_name
let fold = TermDBM.fold
let iter = TermDBM.iter

let to_string term_db = 
  TermDBM.to_string Term.to_string "," term_db




(* add with sharing*)
    
let rec add_ref t db_ref = 
  try find t !db_ref
  with 
    Not_found->
      match t with
      |Term.Fun(sym, args,info) ->
	  let new_args = Term.arg_map (fun t' -> add_ref t' db_ref) args in
	  let new_term = Term.create_fun_term_args sym new_args in 
(* add usefull info for terms*)	  
	  let ()= Term.assign_fun_all new_term in
	  db_ref:=TermDBM.add new_term !db_ref;
	  new_term	   
      |Term.Var(_,_) ->
	  db_ref:=TermDBM.add t !db_ref;
	  Term.assign_var_all t;
	  t


 
let add t db =
  let db_ref = ref db in
  let _ = add_ref t db_ref in
  !db_ref
    
(*debug*)
 let get_greatest_key = TermDBM.get_greatest_key


